%******************************************************************************;
%* SAS macro Crosstab vs. 0.9.2m, 16 Jul 2014, by Jim Groeneveld, Netherlands *;
%******************************************************************************;
%* STILL UNDER CONSTRUCTION, NOT FOR VALIDATION, USE WITH CAUTION AT OWN RISK *;
%*                                                                            *;
%*;%MACRO   CrossTab   /* 9-dimensional crosstabulation with percentages      */
/* -------------------------------------------------------------------------- */
/* ---------- A l w a y s   s p e c i f i e d   a r g u m e n t s ----------- */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
(  Data    =_LAST_     /* input data set                                    R */
,  Group1  =           /* group1 variable name (or list, to be separated)   R */
/*                                                                            */
/* ------ F r e q u e n t l y   s p e c i f i e d   a r g u m e n t s ------- */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
,  Group2  =           /* group2 variable name (or list, to be separated)   O */
,  Group3  =           /* group3 variable name (or list, to be separated)   O */
,  Group4  =           /* group4 variable name (or list, to be separated)   O */
,  Group5  =           /* group5 variable name (or list, to be separated)   O */
,  Group6  =           /* group6 variable name (or list, to be separated)   O */
,  Group7  =           /* group7 variable name (or list, to be separated)   O */
,  Group8  =           /* group8 variable name (or list, to be separated)   O */
,  Group9  =           /* group9 variable name (or list, to be separated)   O */
,  Missing1="Missing"  /* group1 'missing' text, if empty then no missings  O */
,  Missing2="Missing"  /* group2 'missing' text, if empty then no missings  O */
,  Missing3="Missing"  /* group3 'missing' text, if empty then no missings  O */
,  Missing4="Missing"  /* group4 'missing' text, if empty then no missings  O */
,  Missing5="Missing"  /* group5 'missing' text, if empty then no missings  O */
,  Missing6="Missing"  /* group6 'missing' text, if empty then no missings  O */
,  Missing7="Missing"  /* group7 'missing' text, if empty then no missings  O */
,  Missing8="Missing"  /* group8 'missing' text, if empty then no missings  O */
,  Missing9="Missing"  /* group9 'missing' text, if empty then no missings  O */
,  Total1  ="TOTAL"    /* group1 'total' text,   if empty then no totals    O */
,  Total2  ="TOTAL"    /* group2 'total' text,   if empty then no totals    O */
,  Total3  ="TOTAL"    /* group3 'total' text,   if empty then no totals    O */
,  Total4  ="TOTAL"    /* group4 'total' text,   if empty then no totals    O */
,  Total5  ="TOTAL"    /* group5 'total' text,   if empty then no totals    O */
,  Total6  ="TOTAL"    /* group6 'total' text,   if empty then no totals    O */
,  Total7  ="TOTAL"    /* group7 'total' text,   if empty then no totals    O */
,  Total8  ="TOTAL"    /* group8 'total' text,   if empty then no totals    O */
,  Total9  ="TOTAL"    /* group9 'total' text,   if empty then no totals    O */
,  Missings= Exclude   /* I)nclude/E)xclude missing group values in calcu-  O */
                       /* lations of percentages, but always include number   */
,  Across  = Auto      /* =0: group levels vertical, all column variables   O */
                       /* >0: horizontal levels for group 1: row variable     */
                       /* <0: horizontal levels for last group, the row       */
                       /*    variable, swapping row and column percentages    */
                       /* >1, <-1: number of levels of row variable, incl.    */
                       /*    total one, to reserve printing space for         */
                       /* =1, =-1: automatic deduction of number of levels    */
                       /*    (actual number for levels of BY variables may    */
                       /*    be less than the automatically deduced number)   */
                       /* =Yes: 1, =No: 0, =empty: 0                          */
                       /* =Auto: 0 with 1 group, -1 with more groups          */
,  NofCases="freq"     /* statistics column header, if empty then no column O */
     /*"n"*/           /* e.g. 'Freq' 'Count' 'Number' 'N of cases' 'ValidN'  */
,  TablePct=           /* statistics column header, if empty then no column O */
                       /* e.g. 'tbl%' 'table total pct'                       */
,  ColPct  ="col%"     /* statistics column header, if empty then no column O */
     /*"%"*/           /* e.g. 'col%' 'column %' 'within group %' 'wthn col%' */
,  RowPct  =           /* statistics column header, if empty then no column O */
                       /* e.g. 'row%' 'row %' 'between group %' 'btwn row%'   */
,  TwoWyPct=           /* statistics column header, if empty then no column O */
                       /* e.g. '2-way table pct', '2way tbl %'                */
,  Split   =           /* single (quoted) split character for header texts  O */
                       /*    if none, then / in group values split values     */
,  Titles  =0          /* show two standard titles from 1..9, 0=no titles   O */
,  ODS     =           /* empty: no ODS destination, like LISTING, default  O */
                       /* ANY: any ODS destination, except LISTING (REPORT)   */
/*                                                                            */
/* ------- R e g u l a r l y   s p e c i f i e d   a r g u m e n t s -------- */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
,  StatWdth=7          /* width of statistics columns                       O */
,  Decimals=1          /* number of decimals in statistics values           O */
,  ByGroups=           /* BY-variable (list) for subgroups, space-separated O */
,  NinValue=No         /* Y: force group 1 and grand totals in its values   O */
                       /* N: don't, Auto: =Y if Missings=E or Total1 empty    */
,  Force100=No         /* Y: force total percentages of last group to 100%  O */
,  ZeroFreq=No         /* N: no inclusion of rows with all frequencies 0    O */
,  Spacing =Auto       /* spacing between columns, Auto: 2, if across: 1    O */
,  LineSpac=Single     /* or Double between all lines of a table            O */
,  Where   =           /* complete where clause, parentheses not necessary  O */
,  Weight  =           /* WEIGHT variable on WEIGHT statement in PROC FREQ  O */
,  Values1 =           /* group1 value list explicitely wanted if absent    O */
,  Values2 =           /* group2 value list explicitely wanted if absent    O */
,  Values3 =           /* group3 value list explicitely wanted if absent    O */
,  Values4 =           /* group4 value list explicitely wanted if absent    O */
,  Values5 =           /* group5 value list explicitely wanted if absent    O */
,  Values6 =           /* group6 value list explicitely wanted if absent    O */
,  Values7 =           /* group7 value list explicitely wanted if absent    O */
,  Values8 =           /* group8 value list explicitely wanted if absent    O */
,  Values9 =           /* group9 value list explicitely wanted if absent    O */
/*                                                                            */
/* ---- O c c a s i o n a l l y   s p e c i f i e d   a r g u m e n t s ----- */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
,  LineSize=           /* defines page width and length of straight lines   O */
                       /* (#=64-256 (SAS)), if empty then current setting     */
,  TblWidth=           /* width of actual table, should be within LineSize  O */
                       /* (#=1-256), if empty then obtained LineSize value    */
,  Indent  =           /* #: indentation per (second) level of row nesting  O */
                       /* (#=0..TblWidth)                                     */
                       /* Auto: =1 if group column width to small, else none  */
,  LeftLbl =Auto       /* Placement of label of variable before indentation O */
                       /* - Empty   : no column label at all (not used)       */
                       /* - Column  : above column, no matter how narrow      */
                       /* - NextCol : above next (wider) column label         */
                       /* - Value   : prefixed to each individual value       */
                       /* - Header  : as the first (centered) table header    */
                       /* - Auto    : depending on measure of indentation     */
                       /*             and number of group/across variables:   */
                       /*     = indentation 8 or more (or none)   : Column    */
                       /*     = 2 or more normal group variables  : NextCol   */
                       /*     = 1 group + 1 across group variable : Value     */
                       /*     = 1 normal group variable           : Header    */
                       /*     = 1 across group variable           : Empty     */
,  Separate= Auto      /* group number after whose individual levels a      O */
                       /*    separation line must be forced, =0: no line,     */
                       /*    if negative: absolute group number from behind   */
                       /*    =Auto: if Across<0: -3, else -2; if invalid: 0   */
                       /*      (separation after last but 1st column levels)  */
,  NewPage = Auto      /* group number after whose individual levels a      O */
                       /*    new page must be forced, =0: no new page,        */
                       /*    if negative: absolute group number from behind   */
                       /*    =Auto: if Across<0: -4, else -3; if invalid: 0   */
                       /*      (new page after last but 2nd column levels)    */
                       /*    {NewPage generally is smaller than Separate}     */
,  Format1 =           /* group1 format, UNFORMATTED disassociates format   O */
,  Format2 =           /* group2 format, UNFORMATTED disassociates format   O */
,  Format3 =           /* group3 format, UNFORMATTED disassociates format   O */
,  Format4 =           /* group4 format, UNFORMATTED disassociates format   O */
,  Format5 =           /* group5 format, UNFORMATTED disassociates format   O */
,  Format6 =           /* group6 format, UNFORMATTED disassociates format   O */
,  Format7 =           /* group7 format, UNFORMATTED disassociates format   O */
,  Format8 =           /* group8 format, UNFORMATTED disassociates format   O */
,  Format9 =           /* group9 format, UNFORMATTED disassociates format   O */
,  Order1  =INTERNAL   /* Order of Group1 values being presented, see PROC  O */
                       /*   REPORT, DEFINE statement, ORDER attribute, value  */
                       /* - DATA       : unsorted, order as in dataset        */
                       /* - INTERNAL   : unformatted value order              */
                       /* - EXTERNAL   : ??? as FORMATTED ???                 */
                       /* - FORMATTED  : formatted value order                */
                       /* - FREQ       : corresponding frequency order        */
                       /* + DESCENDING : (additionally) reverse order         */
,  Order2  =INTERNAL   /* Order of Group2 values being presented, as Group1 O */
,  Order3  =INTERNAL   /* Order of Group3 values being presented, as Group1 O */
,  Order4  =INTERNAL   /* Order of Group4 values being presented, as Group1 O */
,  Order5  =INTERNAL   /* Order of Group5 values being presented, as Group1 O */
,  Order6  =INTERNAL   /* Order of Group6 values being presented, as Group1 O */
,  Order7  =INTERNAL   /* Order of Group7 values being presented, as Group1 O */
,  Order8  =INTERNAL   /* Order of Group8 values being presented, as Group1 O */
,  Order9  =INTERNAL   /* Order of Group9 values being presented, as Group1 O */
,  Width1st=           /* Preferred width of Group 1 column if specified    O */
   /* New in vs. */    /* If insufficient space left for remaining columns    */
   /* 0.9.2j     */    /*    then this request is not honoured (no change)    */
,  NoTable =/* empty or */ "Dataset $Data empty, no table to present!" /* or  */
                       /* "Dataset $Data where $Where is empty, no table!"    */
                       /* Text to present with empty table, none if empty,  O */
                       /*    If text not between single quotes then $ char.   */
                       /*    replaces any argument by its parameter value     */
/*                                                                            */
/* ---------- R a r e l y   s p e c i f i e d   a r g u m e n t s ----------- */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
,  CalledBy=           /* Macro name of macro or program for err0r report   O */
,  Version = 0.9.2m    /* forced version specification for version control  O */
/*                                                                            */
/* --------- N e w ,   e x p e r i m e n t a l   a r g u m e n t s ---------- */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
,  ColPcRef=           /* statistics reference variable or (constant) value O */
                       /* serving as the basis for calculating percentages    */
                       /* with optional, quoted column header (default COL%), */
                       /* If empty then no concerning percentage column.      */
                       /* E.g. 'col%' 'column %' 'within column %'. Unlike    */
                       /* ColPct, calculating percentages within the last,    */
   /* New in  */       /* non-across group, this calculates percentages       */
   /* version */       /* relative to a specified reference value for the     */
   /* 0.9.2f  */       /* entire column. This may be a constant value or one  */
                       /* stored in a specified variable, which may differ    */
   /* EXPERIMENTAL  */ /* among sub groups and has to be present in the data. */
   /* MAY BECOME    */ /* If specified the argument value must consist of     */
   /* DEPRECATED    */ /* one or two space separated values:                  */
                       /* 1. a constant numerical value or variable name,     */
                       /* 2. an optional quoted column label, default "COL%"  */
                       /* E.g. <ColPcRef=ColTotal "Column %">                 */
/* Limitation: if variable name than NOT (yet) applicable to group Totals.    */
,  Out     =  /*092L*/ /* REPORT dataset [lib.]name to output table data    O */
,  OverWrit=No/*092L*/ /* specify Yes to overwrite an existing Out dataset  O */
,  Out2    =  /*092L*/ /* prepared input dataset [lib.]name for PROC REPORT O */
,  Ovrwrit2=No/*092L*/ /* specify Yes to overwrite an existing Out2 dataset O */
/*                                                                            */
/* ----------- N e v e r   s p e c i f i e d   a r g u m e n t s ------------ */
/* Argument Default       Description and remarks      Required/Optional: R/O */
/* -------- --------      --------------------------------------------------- */
,  ByGrpUse=FREQ       /* BY: use BY-variables as such with FREQ (standard) O */
                       /*    after SORTing to unformatted values as usual     */
                       /*    (not supporting non-unique formatted BY-var.s)   */
/* EXPERIMENTAL, */    /* TABLE: use BY-variables with FREQ in TABLE          */
/* DO NOT CHANGE */    /*    (supporting any kind of formatted BY-variables)  */
                       /*    (producing all combinations of BY-variables)     */
                       /* FREQ: alternative of formatted sort with BY-var.s   */
                       /*    in extra FREQ, resulting in aggregated dataset   */
                       /*    (supporting any kind of formatted BY-variables)  */
,  PctAcros= Improved  /* Improved: with Across: RowPct from Across row     O */
          /* 0.9.1u */ /* Original: with Across: RowPct from last-1 column    */
,  Debug   = 0         /* Debug level; for testing, debugging purposes only O */
,  ForMyUse=           /* argument for the program's use only, don't use it O */
)/ DES     =              '9-dimensional crosstabulation' /*Store*/            ;
%*                                                                            *;
%* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*;
%*                                                                            *;
%* File       : CrossTab.SAS / CrossTab.092L                                  *;
%*                                                                            *;
%* Purpose    : 1 to 9-dimensional crosstabulation with optional percentages  *;
%*                                                                            *;
%* Programmer : Jim Groeneveld                                                *;
%* Date       : 16 Jul 2014                                                   *;
%* Version    : 0.9.2m                                                        *;
%*                                                                            *;
%* SAS version: 6.12 under Windows 95 / 8.2 under Windows 2K / XP             *;
%*                                                                            *;
%* Validation : -                                                             *;
%*                                                                            *;
%* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*;
%*                                                                            *;
%* Output:                                                                    *;
%* =======                                                                    *;
%* A REPORT table containing crosstabulation information with a suited layout.*;
%* Table layout and contents may be adapted using arguments.                  *;
%*                                                                            *;
%* Examples:                                                                  *;
%* =========                                                                  *;
%*                                                                            *;
%* Minimum specification:                                 Macro call:         *;
%* ----------------------                                 -----------         *;
/* Crosstabulation on/with:                               %CrossTab (         */
%* - input data file InputDs                              DATA=InputDs,       *;
%* - a single grouping variable Group                     Group1=Group);      *;
%* - remaining arguments default.                                             *;
%*                                                                            *;
%* More extensive specification:                          Macro call:         *;
%* -----------------------------                          -----------         *;
/* Crosstabulation on/with:                               %CrossTab (         */
%* - input data file InputDs                              DATA=InputDs,       *;
%* - a first grouping variable One                        Group1=One,         *;
%* - a specified format for One: OneFmt                   Format1=OneFmt,     *;
%* - a second grouping variable Two                       Group2=Two,         *;
%* - an explicitely specified text in case of missings    Missing2="unknown", *;
%* - forcing at least some specific values for group 2    Values2=. 0 1 2,    *;
%* - an explicitely specified text of its total number    Total2="Size Two",  *;
%* - a third grouping variable Three                      Group3=Three,       *;
%* - a disabled associated format for variable Three      Format3=Unformatted,*;
%* - excluding missing values for variable Three          Missing3=,          *;
%* - excluding total   values for variable Three          Total3=,            *;
%* - forcing levels of One horizontally in columns        Across=1,           *;
%* - requesting statistics with column texts for          NofCases="Freq",    *;
%*   arguments as showed on the right (excluding          TablePct="Tbl%",    *;
%*   the within group 3 percentage, that is not           ColPct  ="Col%",    *;
%*   specified or specified with an empty value)          RowPct  ="Row%",    *;
%* - a list of stratification variables                   ByGroups=VarA VarB, *;
%* - forcing expression of '(N=#)' in labels of var One   NinValue=Y,         *;
%* - forcing total percentages of var Three to 100%       Force100=Y,         *;
%* - forcing expression of rows with 0-frequencies        ZeroFreq=Y,         *;
%* - redefining width of statistics columns as 4          StatWdth=4,         *;
%* - forcing the number of printed decimals to 2          Decimals=2,         *;
%* - leaving spacing between columns and lines default    {no specification}  *;
%* - suppressing separation lines within the table        Separate=0,         *;
%* - forcing a new page after each value of last but 3rd  NewPage=-4,         *;
%* - allowing for a total table width of 150 characters   TblWidth=150,       *;
%* - (this needs to specify a similar minimum LineSize)   LineSize=150,       *;
%* - forcing indentation and separation of Two and Three  Indent=10,          *;
%* - forcing placement of label of Two in table value     LeftLbl=Value,      *;
%* - enabling the active split-character as a vert. bar   Split=|,            *;
%* - enabling automatic titles from title line 6          Titles=6            *;
%* - leaving the remaining arguments default              );                  *;
%*                                                                            *;
%* Remarks:                                                                   *;
%* ========                                                                   *;
%* If many group variables are specified, processing may take some time,      *;
%* due to very frequent disk (network) access.                                *;
%* An optional RAM disk for WORK datasets might improve performance.          *;
%* An experiment showed an improvement of 25 to 30% and much less noise.      *;
%*                                                                            *;
%* After each level of the last but one group variable an empty separation    *;
%* line always automatically is included. An additional separation line,      *;
%* consisting of a straight, full width line, is optional.                    *;
%*                                                                            *;
%* Used auxiliary macros:                                                     *;
%* ----------------------                                                     *;
%* = internal: - CompBloc                                                     *;
%* = attached: - Spacing0                                                     *;
%* = external: - ChkVar, FirstCh, ChkExist                                    *;
%*                                                                            *;
%* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*;
%*                                                                            *;
%* History of CrossTab:                                                       *;
%* ====================                                                       *;
%* version  date         description of changes, additions, improvements      *;
%* -------  -----------  ---------------------------------------------------- *;
%* 0.1      22 Apr 1999  first working release (with PROC TABULATE only)      *;
%* 0.2      11 May 1999  made suitable for both num. and char. group variables*;
%*                       minor changes to argument names and feedback         *;
%*                       included processing of special missing values        *;
%*  -       20 May 1999  changed some field widths for frequencies            *;
%*  -        9 Jun 1999  added Titles and Version arguments                   *;
%*  -       23 Jun 1999  added LineSize and Group#N arguments                 *;
%*  -       24 Jun 1999  added Decimals=1 argument                            *;
%*  -       25 Jun 1999  added TblWidth argument                              *;
%*  -       29 Jun 1999  added arguments StatWdth, NofCases, TablePct, ColPct,*;
%*                                       RowPct, WGrp3Pct and BoxText         *;
%* 0.21      2 Jul 1999  added code to compile but skip this macro further    *;
%*  -       21 Jul 1999  changed variable characteristics storage internally  *;
%*                       removed outdated width interpretation of Across      *;
%*  -       22 Jul 1999  added presorting according to BY variable list,      *;
%*                          which should have been present earlier already    *;
%* 0.30     22 Jul 1999  added auxiliary macros BAND (& BOR) returning Result *;
%*  -       23 Jul 1999  finished preparation with FREQ for use of REPORT     *;
%*                       added Missing argument (exclude missings from calcs) *;
%*  -       16 Sep 1999  finished programming table using PROC REPORT         *;
%*                       added Force100 argument to show totals as 100%       *;
%* 0.31     16 Sep 1999  changed Across values to represent number of levels  *;
%*                          of first group variable, used in calculations     *;
%*  -       17 Sep 1999  added global OPTIONS MISSING=' ' statement           *;
%*  -       21 Sep 1999  added LeftLbl argument for label placement           *;
%*  -       22 Sep 1999  added Spacing argument for manual spacing            *;
%*                       added UNFORMATTED value to Grp#Fmt to disassociate   *;
%*                       added LineSpac argument for single or double spacing *;
%* 0.32     24 Sep 1999  added NinValue argument for totals in group1 classes,*;
%*                          general algorithm using a new character variable  *;
%*  -       27 Sep 1999  added a better, specific algorithm to use if no      *;
%*                          ByGroups specified, using an alternative format   *;
%*  -       28 Sep 1999  changed fixed temporary file name into pseudo random *;
%*  -       30 Sep 1999  added check for existing auxiliary temporary file    *;
%*  -        1 Oct 1999  changed table totals to represent the total number of*;
%*                          valid observations (without missings) if Missing=E*;
%*                       reversed missing value placement if Missing=E        *;
%*                       added Separate argument to force additional lining   *;
%*  -        4 Oct 1999  changed Missing argument into Missings argument      *;
%*                       changed Grp#Mis into Missing# argument per variable, *;
%*                          specifying the variables 'missing' text as well   *;
%*  -        5 Oct 1999  adapted to GPP guidelines and layout for macros      *;
%*                       changed argument names for variables, formats, totals*;
%*                          (Grp#Var->Group#,Grp#Fmt->Format#,Group#N->Total#)*;
%*  -        6 Oct 1999  added First auxiliary macro, simplifying source code *;
%*                       further adaptation to GPP guidelines, checks, locals *;
%*                       added check for matching variable type and format    *;
%* 0.90      7 Oct 1999  extended crosstabulation dimension from 3 to 9       *;
%*                       removed all code with respect to PROC TABULATE       *;
%*                       removed all code with respect to macro BOR           *;
%*                       added WHERE argument to add a complete WHERE clause  *;
%*                       changed argument name WGrp3Pct into TwoWyPct, as     *;
%*                          a percentage with regard to a 2-way table total   *;
%*                          (of last two groups) is what PROC FREQ produces   *;
%* 0.91      7 Oct 1999  added Values# arguments, forcing showing group values*;
%*  a.      11 Oct 1999  changed NinValue=Auto processing to more logical one *;
%*                       added value Auto to Indent for too small columns     *;
%*                       changed LineSize action into LS arg with PROC REPORT *;
%*                       added NewPage argument to specify new page condition *;
%*                       added basic check on duplicate group variable names  *;
%*                       added automatic deduction of number of group 1 levels*;
%*  b.      12 Oct 1999  changed Separate argument values, similar to NewPage *;
%*                       changed LineSize interpretation forcing longer lines *;
%*  c.      13 Oct 1999  added negative Across values indicating last group   *;
%*  d.      14 Oct 1999  added resetting temporary changed options when ready *;
%*                          and reading empty LineSize arg from LS setting    *;
%*                       added setting empty TblWidth equal to LineSize       *;
%*                       added checks on LineSize and dependent TblWidth      *;
%*  e.      15 Oct 1999  added run time determination and report              *;
%*  f.      21 Oct 1999  added ByGrpUse argument for processing BY-variables  *;
%*                       corrected a major bug in a complicated instance      *;
%*                       changed argument name ByVarLst into ByGroups         *;
%*  g.      25 Oct 1999  added ByGrpUse argument value FREQ, allowing for     *;
%*                          alternative formatted sorting and aggregation     *;
%*                       corrected a slight bug in the layout (final line)    *;
%*                       changed layout of double line space (empty before)   *;
%*  h.      27 Oct 1999  added Order# arguments for specifying REPORT ORDER   *;
%*  i.       3 Nov 1999  corrected several minor bugs, improved some code     *;
%*                       set MISSING='.' for calculations and ' ' for REPORT  *;
%*                       switched sequence of certain blocks of code          *;
%*  j.       9 Nov 1999  added internal macro variables Grp#Len (character)   *;
%*                       added support for longer character values than 8     *;
%*  k.      22 Nov 1999  corrected bug in handling missing num & char values  *;
%*  l.      10 Dec 1999  removed macro %BAND and used %SYSFUNC(BAND instead   *;
%*                       some minor code alterations (order of execution)     *;
%*                       correction of illegal Where with not-group variables *;
%*                       changed Version argument into ForMyUse argument      *;
%*                       added Q&D support for concatenated groups: varlists, *;
%*                          generating of recursive calls with single vars    *;
%*                       simplified generating horizontal lines with LineSize *;
%*                       corrected bug with explicit values and BY-groups     *;
%*  m.      15 Dec 1999  corrected buggy processing of associated num. format *;
%*  n.      24 May 2000  corrected buggy processing of across group list,     *;
%*                       corrected insufficient existence check on group vars *;
%*  o.       9 Apr 2004  corrected double spacing with only one group var.,   *;
%*                       corrected some (minor) bugs, a.o. with var lists,    *;
%*                       changed defaults of Data, NinValue, ZeroFreq, Split, *;
%*                       corrected double listing of single across variable,  *;
%*                       adapted PROC CONTENTS Name into UPCASE(Name) because *;
%*                          of SAS 8.2 backwards incompatibility with 6.12    *;
%*  p.       3 Jun 2005  corrected bug with WHERE parameter (QUOTE in code),  *;
%*                       improved immediate deletion of temporary datasets,   *;
%*                       changed order of importance of input parameters      *;
%*          16 Jun 2005  fixed superfluous recursive tables with group lists, *;
%*          17 Jun 2005  added Debug control, minor improvements (MacDate),   *;
%*                       added Version control, fixed buggy Group3 if more,   *;
%*                       added Data=_LAST_ support                            *;
%*  q.      28 Jun 2005  reversed Separate and NewPage group number meaning,  *;
%*                       improved GrpList display of 9th group in title line, *;
%*          29 Jun 2005  added Auto value for Across, NewPage and Separate    *;
%*                         and extensive checking and processing of these,    *;
%*                       removed old Across_ auxiliary macro variable         *;
%*          16 Sep 2005  corrected and redesigned algorithm to generate       *;
%*                         pseudo random, unique, temporary filename          *;
%*  r.       6 Oct 2005  fixed bugs with Separate and NewPage in certain      *;
%*                         circumstances, and changed interpretation of both  *;
%*  s.      19 Oct 2005  changed code of auxiliary macro First and its name   *;
%*                         to FirstCh, and made it external as FirstCh.sas    *;
%*          20 Oct 2005  corrected SAS WARNING "only BREAK on GROUPing and    *;
%*                         ORDERing variables", for the grand total           *;
%*          28 Oct 2005  corrected minor problems with undefined &err, &warn  *;
%*          30 Jun 2006  surrounded &TempPath by %QUOTE in [IF (&TempPath NE)]*;
%*                         because of ~ chars in shortened DOS path names     *;
%*          21 Jul 2006  removed buggy check on Across values with N_Groups   *;
%*        8+14 Aug 2006  corrected another two buggy checks on Across values  *;
%*           9 Aug 2006  improved Separation lines a little bit (not perfect) *;
%*          16 Aug 2006  corrected test on &&Values&I with %QUOTE function    *;
%*       17+24 Aug 2006  added checking for and reporting of empty dataset    *;
%*  t.      28 Sep 2007  added SwRowCol arg to swap row and column percentages*;
%*                          with 3 groups or more as temporary kludge         *;
%*  u.      17 Oct 2007  changed SwRowCol argument to PctAcros argument with  *;
%*                          values Improved (default) and Original (never     *;
%*                          used) to solve Across percentages permanently     *;
%*NO(same)  18 Oct 2007  forced printing of empty 2-way percentages as 100 NO *;
%*  v.      Feb/Mar2010  experimental code: indented, dotted separation line  *;
%*  w.      14 Apr 2010  undone above experimental code, unreliable, debug!,  *;
%*                       added Weight argument for WEIGHT in PROC FREQ        *;
%*  0.9.2a  20 Apr 2011  added ODS argument to support ODS destinations other *;
%*                          than LISTING: adaptation of PROC REPORT code and  *;
%*                          prevent printing of temporary datasets            *;
%*  0.9.2b  29 Apr 2011  improved Values# arguments to allow for quoted text  *;
%*                          values with embedded spaces [%SYSFUNC(SCANQ(...]  *;
%*                          and forced order of values specified              *;
%*                       added feedback on Version number (long forgotten),   *;
%*                       improved missing value handling, minor improvements  *;
%*  0.9.2c  19 Oct 2011  changed RUN into QUIT after every PROC DATASETS      *;
%*  0.9.2d  21 Nov 2013  fixed bug with character field lengths and formats   *;
%*  [urgent bug fix]       above 999 (was maximised to 3 digits, now to 5),   *;
%*                       minor improvements and added debugging code          *;
%*  0.9.2e  26 Nov 2013  added temporary, experimental argument PctRef,       *;
%*                         specifying the variable (or value) to use as a     *;
%*                         reference in calculating the column percentages,   *;
%*                         both for the individual frequencies and totals.    *;
%*                         This feature will be changed in an incompatible    *;
%*                         way in the next version,                           *;
%*                       minor improvements, e.g. ending PROC DATASETS with   *;
%*                         both RUN and QUIT                                  *;
%*  0.9.2f  27 Nov 2013  removed temporary, experimental argument PctRef,     *;
%*                       added (still experimental) argument ColPcRef         *;
%*  (same)  11 Dec 2013  fixed programming bug with one group [% LET]         *;
%*  0.9.2g  13 Jan 2014  fixed programming bug with ByGroups and NinValue: ], *;
%*  [urgent bug fix]     added deletion of all temporary datasets at the end, *;
%*                       fixed buggy, unwanted totals in specific situations  *;
%*                         with temporary, makeshift solution, to be solved   *;
%*                         later by a permanent fix at the source (to find)   *;
%*  0.9.2h  20 Jan 2014  replaced above temporary solution by a permanent one *;
%*  [urgent bug fix]       solving the cause of the bug with totals (...)     *;
%*  0.9.2i  31 Jan 2014  fixed bug with too early semicolon [urgent bug fix]  *;
%*  0.9.2j   6 Feb 2014  added Width1st argument, requesting deviant width    *;
%*                         for final column 1, if sufficient space available, *;
%*                       added CalledBy argument                              *;
%*  0.9.2k  14 Feb 2014  fixed buggy percentage calculations with ColPcRef    *;
%*  [urgent bug fix]        and more than 2 groups                            *;
%*  0.9.2L  29 Apr 2014  improved version checking with UPCASE,               *;
%*                       Split character may be surrounded by normal quotes,  *;
%*                       added arguments Out= and Overwrit= to save REPORT    *;
%*                          OUTput dataset (without ByGroups specification),  *;
%*                       added arguments Out2= and Ovrwrit2= to save REPORT   *;
%*                          INput dataset (same for Group _list_ variables),  *;
%*                       (minor) code improvements                            *;
%*          30 Apr 2013  fixed minor bug with Width1st and 2 groups only,     *;
%*                       changed producing an empty line after the last group *;
%*                          variable only if its global number of levels > 1, *;
%*                       improved buggy skipped lines in table for 3 groups   *;
%*                          and more (still to check whether as desired now), *;
%*                       added support for macro quoted Where values          *;
%*           9 May 2013  fixed bug with Order# values processed incorrectly   *;
%*                          with negative Across values (wrong for > 14 yrs), *;
%*                       changed producing PROC REPORT code (LIST) if Debug=9,*;
%*                       minor programming improvements                       *;
%* 0.9.2m   16 Jul 2014  fixed minor bug reporting non-existent err0r         *;
%*                                                                            *;
%* Known bugs:                                                                *;
%* ===========                                                                *;
%* 1. no wrap and faulthy placement of labels and (formatted) values of       *;
%*      across variables with nested multiple columns due to SAS bug!         *;
%*                                                                            *;
%* Future features: (see also separate to-do-lists of author)                 *;
%* ================                                                           *;
%* ????????????????      no deduced argument names                            *;
%* 0.extensive argument checks ((non-)existence, validity, interconsistency   *;
%* a.solution for secure compiling, making unwanted decompiling impossible    *;
%* b.if desired: optionally presenting totals before instead of after values  *;
%* c.improvement of the indentation feature to include all but one variable   *;
%* d.optional exclusion of missing values for BY group variables via argument *;
%* e.concatenation of a list of group variables in one table. Presentation w/ *;
%*     either an additional initial variable name/label column or row         *;
%* f.discrimination of different kinds of numeric missing values (., .a - .z) *;
%* g.specification of formats for BY variables {if at all applicable for BY}  *;
%* h.optional over(under)line totals only for visual separation from rest     *;
%* i.NinValue argument extension to other group variables than only first one *;
%* j.LineSpac=Auto: Double, except if not fitting on one page (how to know?)  *;
%* k.if Split is empty (not space!?????????) FLOW should be absent @@@@@@@@@  *;
%* l. multiples of columns and spacing may be smaller than full table width:  *;
%*    either solve by extra spacing before statistics (across or group vars)  *;
%*    or insert dummy non-printable column with rest spacing in between.      *;
%* m.backup and restore initial ODS state for SAS 9.1 and SAS 9.2 / 9.3 / 9.4 *;
%* n.ColPcRef: also make useful for Total rows and columns (extrapolate/dset) *;
%*                                                                            *;
%******************************************************************************;

%* OPTIONS MPRINT MERROR SERROR MLOGIC SYMBOLGEN MACROGEN;
%*LET Debug=1;

  %LOCAL    /* Define internal macro variables explicitely local */
    MacName  /* This macros external name: Crosstab */
    MacVs    /* Version number major.minor.patchSub of macro: 0.9.2m */
    MacDate  /* Date of this version of macro: 16 Jul 2014 */
    N_Dimens /* Maximum dimension supported for groups, currently 9 */
    i j g    /* three element indexes */
    Group    /* element of concatenated group varlist */
    N_Groups /* number of group variables */
    ArgList  /* (1) argument list for recursive calls */
             /* (2) List of user specifiable macro arguments */
    Argument /* Single user specifiable macro argument */
    Timing   /* Start time or run time */
    Contents /* stand-in name for Contents dataset ___Cont_ */
    ErrCount /* number of erroneously specified arguments */
    Err      /* text 'E R R O R' as consecutive characters */
    Warn     /* text 'W A R N I N G' as consecutive characters */
    GrpStart /* Starting group number dependent on SwColRow */
    GrpStop  /* Stopping group number dependent on SwColRow */
    GrpIncr  /* Increment of group number dependent on SwColRow */
  ;

  %LET MacName  = Crosstab;
  %LET MacVs    = 0.9.2m;
  %LET MacDate  = 16 Jul 2014;
  %LET Contents = ___Cont_;
  %LET Err      = %SYSFUNC(COMPRESS(E R R O R, %STR( )));
  %LET Warn     = %SYSFUNC(COMPRESS(W A R N I N G, %STR( )));

 %IF ( %UPCASE(&ForMyUse) = COMPILE ) %THEN %DO;
   %Spacing0 (ForMyUse=Compile);
   %GOTO Finish;
 %END;
 %ELSE %IF ( %UPCASE(&ForMyUse) = RECURSIVE ) %THEN %GOTO HeadSkip;

%IF (&Debug EQ 1 OR &Debug GT 11) %THEN %DO;
  OPTIONS MPRINT MERROR SERROR MLOGIC SYMBOLGEN MACROGEN;
%END;
%* Define libname Current if Debug = 9;
%IF (&Debug EQ 9) %THEN LIBNAME Current '.';;

%*~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Macro header in LOG file;
%*_________________________;

  %PUT;
  %PUT |~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|;
  %PUT |   Macro &MacName, vs. &MacVs, by Jim Groeneveld, &MacDate  |;
  %PUT |        9-dimensional crosstabulation with percentages        |;
  %PUT |______________________________________________________________|;
  %PUT;

%* Feedback of specified arguments, programmed as macro loop;
  %PUT &MacName: Review of argument specifications (incl. defaults);
  %LET ArgList = Data Group1 Missing1 Total1 Values1 Format1 Order1 Width1st
                      Group2 Missing2 Total2 Values2 Format2 Order2
                      Group3 Missing3 Total3 Values3 Format3 Order3
                      Group4 Missing4 Total4 Values4 Format4 Order4
                      Group5 Missing5 Total5 Values5 Format5 Order5
                      Group6 Missing6 Total6 Values6 Format6 Order6
                      Group7 Missing7 Total7 Values7 Format7 Order7
                      Group8 Missing8 Total8 Values8 Format8 Order8
                      Group9 Missing9 Total9 Values9 Format9 Order9
                 Missings Across NofCases TablePct ColPct RowPct TwoWyPct
                 ColPcRef Split Titles ODS Where Weight
                 StatWdth Decimals Bygroups NinValue Force100 ZeroFreq Spacing LineSpac
                 LineSize TblWidth Indent LeftLbl Separate NewPage NoTable
                 Out Overwrit Out2 Ovrwrit2
                 CalledBy Version Debug ByGrpUse PctAcros ForMyUse;
  %PUT &MacName: Review of argument specifications (incl. defaults);
  %LET I = 1;
  %LET Argument = %SCAN ( &ArgList, &I, %STR( ) );
  %DO %WHILE (%LENGTH(&Argument));
    %PUT &MacName: &Argument = &&&Argument;
    %LET I = %EVAL ( &I + 1 );
    %LET Argument = %SCAN ( &ArgList, &I, %STR( ) );
  %END;
  %PUT;
  %PUT &MacName: See SAS log for other characteristics;

%HeadSkip:

  %IF (%LENGTH(%SUPERQ(Version)) AND %UPCASE(&Version) NE %UPCASE(&MacVs)) %THEN %DO;
    %PUT *** &MacName *** &ERR: Specified version &Version does not match &MacVs,;
    %PUT .                       macro &MacName will abort;
    %GOTO Exit;
  %END;

%* Process keyword _LAST_ with Data;
  %IF (%UPCASE(&Data) EQ _LAST_) %THEN %LET Data = &SYSLAST;

  %LET N_Dimens = 9;
  %LET Timing   = %SYSFUNC(TIME());

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Determine number of specified (group) variables ;
%*_________________________________________________;

  %LET N_Groups = &N_Dimens; %* Fixed max N of variables, might be unlimited;
  %DO %WHILE (&&Group&N_Groups EQ); %* Determine number of specified variables;
    %LET N_Groups = %EVAL(&N_Groups-1); %* If from list count number of elements;
  %END;                               %* &N_Groups now contains actual N of vars;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Process concatenated group variable lists, forcing single recursive calls ;
%*___________________________________________________________________________;

  %LET J = 0; %* for overall check on variable lists below;
  %DO i = 1 %TO &N_Groups; 
    %IF (&J NE 0) %THEN %GOTO Exit; %* extra code to avoid duplicate combinations;
/*========= future optional feature
    %IF ( ( &Across LT 0 AND &i EQ &N_Groups-1 )
      OR ( NOT ( &Across LT 0 ) AND &i EQ &N_Groups ) ) %THEN %DO;
%* Don`t process last _vertical_ group here;
    %END; %* That group is processed dedicately for concatenated variables;
    %ELSE 
=========*/
    %IF ( %SCAN(&&Group&i,2,%STR( )) NE ) %THEN %DO;
      %LET j = 1;
      %LET Group = %SCAN(&&Group&i,&j,%STR( ));
      %DO %WHILE ( &Group NE ); %* Force recursive calls to this macro;
        %LET ArgList = %NRSTR(%%CROSSTAB %(Data=&Data);
           %DO g = 1 %TO &N_Groups;
             %IF ( &g EQ &i ) %THEN
                   %LET ArgList = &ArgList %STR(, Group&g = &Group);
             %ELSE %LET ArgList = &ArgList %STR(, Group&g = &&Group&g);
           %END;
           %DO g = 1 %TO &N_Groups;
              %LET ArgList = &ArgList
                ,  Format&g  = &&Format&g
                ,  Missing&g = &&Missing&g
                ,  Total&g   = &&Total&g
                ,  Values&g  = &&Values&g
                ,  Order&g   = &&Order&g  ;
           %END;
            %LET ArgList = &ArgList
                ,  Missings=&Missings
                ,  ByGroups=&ByGroups
                ,  Across  =&Across
                ,  NinValue=&NinValue
                ,  Force100=&Force100
                ,  ZeroFreq=&ZeroFreq
                ,  NofCases=&NofCases
                ,  TablePct=&TablePct
                ,  ColPct  =&ColPct
                ,  RowPct  =&RowPct
                ,  TwoWyPct=&TwoWyPct
                ,  StatWdth=&StatWdth
                ,  Decimals=&Decimals
                ,  Spacing =&Spacing
                ,  LineSpac=&LineSpac
                ,  Separate=&Separate
                ,  NewPage =&NewPage
                ,  LineSize=&LineSize
                ,  TblWidth=&TblWidth
                ,  Indent  =&Indent
                ,  LeftLbl =&LeftLbl
                ,  Split   =&Split
                ,  Where   =&Where
                ,  Weight  =&Weight
                ,  Titles  =&Titles
                ,  ODS     =&ODS
                ,  ColPcRef=&ColPcRef
                ,  Width1st=&Width1st
                ,  ByGrpUse=&ByGrpUse
                ,  Out     =&Out
                ,  Overwrit=&Overwrit
                ,  Out2    =&Out2
                ,  Ovrwrit2=&Ovrwrit2
                ,  Debug   =&Debug      /* Version may be left empty */
                ,  ForMyUse=RECURSIVE
                );
        %UNQUOTE (&ArgList);
        %LET j = %EVAL ( &j + 1);
        %LET Group = %SCAN(&&Group&i,&j,%STR( ));
      %END; %* --- %DO %WHILE .........;
    %END; %* --- Multiple Group# processing from list / recursive call;
  %END; %* --- %DO i = 1 %TO &N_Groups;
  %IF ( &j NE 0 ) %THEN %GOTO Exit;


%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* LOCAL macro variables declarations;
%*___________________________________;

  %LOCAL i j /* Define internal macro variables explicitely local */
    Grp1Type /* types of group variables: 1 or 2 */
    Grp2Type Grp3Type Grp4Type Grp5Type Grp6Type Grp7Type Grp8Type Grp9Type
    Grp1Lbl  /* labels (or names) of group variables */
       Grp2Lbl Grp3Lbl Grp4Lbl Grp5Lbl Grp6Lbl Grp7Lbl Grp8Lbl Grp9Lbl
    GrpFmt1  /* associated formats of group variables */
       GrpFmt2 GrpFmt3 GrpFmt4 GrpFmt5 GrpFmt6 GrpFmt7 GrpFmt8 GrpFmt9
    Grp1Fmt  /* substitute Format# arguments, get modified */
       Grp2Fmt Grp3Fmt Grp4Fmt Grp5Fmt Grp6Fmt Grp7Fmt Grp8Fmt Grp9Fmt
    Contents /* stand-in name for CONTENTS output dataset __contDs */
    XtabData /* stand-in name for intermittent data __xTabDs */
    AggrPart /* stand-in name for aggregated, partial data __partDs */
    AggrData /* stand-in name for aggregated data __dataDs */
    Grp1Part /* stand-in name for aggregated, partial group 1 data __v1Part */
    Grp1Data /* stand-in name for aggregated group 1 data __v1Data */
    Val0Data /* stand-in name for artificial zero statistics on values __v0Data */
    Constant /* stand-in name for ___Const */
    Dummy    /* stand-in name for ___Dummy */
    LastCase /* stand-in name for ___Last */
    GrpValue /* stand-in name for ___Value */
    Missing_ /* substitute for argument Missings, gets modified */
    NinValu_ /* substitute for argument NinValue, gets modified */
    Indent_  /* substitute for argument Indent,   gets modified */
    LeftLbl_ /* substitute for argument LeftLbl,  gets modified */
    Titles_  /* substitute for argument Titles,   gets modified */
    Titling  /* all automatic titles */
    LineSkip /* either empty or SKIP, dependent on LineSpac */
    GrpList  /* the variable list, made up from Group1, Group2, and so on */
    GrpName  /* element of GrpList, Group# (varying #) actually, or of ByGroups */
    GrpFmLst /* the list of format macro variables (not their contents, if any) */
    FGrp1Fmt /* 'F=format' specification for each group var */
       FGrp2Fmt FGrp3Fmt FGrp4Fmt FGrp5Fmt FGrp6Fmt FGrp7Fmt FGrp8Fmt FGrp9Fmt
    SortList /* specific group list in which another variable stands first */
    Value    /* value list of Values# for a group variable */
    Order    /* value of Order# for a group variable */
    LastBut1 /* number of group variables, where more than one, minus one */
    Grp11st  /* variable type format prefix: num: _, char: $ */
       Grp21st Grp31st Grp41st Grp51st Grp61st Grp71st Grp81st Grp91st
    NumTotal /* numeric 'total' value, dependent on Missing_ */
    ChrTotal /* character 'total' value, dependent on Missing_ */
    NumMis   /* numeric substitute missing value, dependent on Missing_ */
    ChrMis   /* character substitute missing value, dependent on Missing_ */
    ByVarLst /* ByGroups with spaces replaced by asterisks, used with ByGrpUse */
    Request  /* the PROC FREQ TABLES statement being built, all combinations (with *) */
    Dimensio /* dimension of a specific Request, one of the combinations */
    ExclList /* exclusion list of a Request, the var numbers not in the Request */
    ExcVarNr /* element of ExclList */
    InclType /* inclusion type, like _TYPE_ with PROC MEANS */
    FmtName  /* temporary, extended format name with missings and totals */
    TempPath /* path name of temporary directory from environment variable TEMP */
    FileName /* pseudo-random, unique scratch file name, including path */
    Grp1Var  /* deduced Group1 character variable with missings and Totals */
    Grp1nFmt /* deduced Group1 character format with missings and Totals */
    Grp1Lvls /* name of temporary variable representing number of observations */
    NumStats /* number of statistics requested */
    StatSize /* total width of all statistics in REPORT table */
    ClasSize /* total remaining width of left group categories */
    PctCol   /* either Percent or _Pct_Col */
    LeftVar  /* leftmost group variable in REPORT table, dependent on Across */
    NextVar  /* next to left group variable in REPORT table, dependent on Across */
    VarUsage /* type of REPORT variable, either empty or GROUP */
    EmptyLbl /* empty or original label above empty, alternative column */
    NextLbl  /* empty or combined left and next labels above next column */
    LblAsVal /* empty or original label prefixing concerning values */
    LblAsHdr /* empty or original label as table header */
    Spacing0 /* either empty or 'SPACING=0' */
    GrpWidth /* width of single group column, deduced from other measures */
    PrintCol /* either empty or NOPRINT */
    EmptyCol /* either completely empty or a single space only */
    EmptyDef /* varying DEFINE and COMPUTE statements within PROC REPORT */
    DGroup2  /* DEFINE statements for group2 to group 9 */
       DGroup3 DGroup4 DGroup5 DGroup6 DGroup7 DGroup8 DGroup9
    Break    /* BREAK block within PROC REPORT */
    LineLen  /* line length, either LineSize or TblWidth */
    LineLine /* a number of &LineLen underline characters, used for REPORT */
    ErrCount /* number of erroneously specified arguments */
    Err      /* text 'E R R O R' as consecutive characters */
    Warn     /* text 'W A R N I N G' as consecutive characters */
    oLS      /* original option LINESIZE setting */
    oMissing /* original option MISSING  setting */
    WhereObs /* number of observations in dataset after WHERE condition */
    DelList  /* list of element delimiters in lists */
    HeadHead /* HEADLINE HEADSKIP in no-ODS mode with PROC REPORT, else empty */
    HorLineA /* '--' (auto-width) in no-ODS mode with PROC REPORT, else empty */
    HorLineB /* '__' (auto-width) in no-ODS mode with PROC REPORT, else empty */
    HorLineC /* "&LineLine" (calculated) in no-ODS mode with PROC REPORT */
    LastSkip /* skip line at e-o-t: SKIP in no-ODS mode with PROC REPORT */
    OrderVar /* temporary variable remembering order of specified values */
    CpRefVar /* first element of &ColPcRef, (numeric value or) variable name */
    CpRefVal /* first element of &ColPcRef, numeric value, CpRefVar made empty */
    CpRefLbl /* second element of &ColPcRef, column label (normal quoted) */
    Grp1Wdth /* deviant, requested width for Group1 column */
    GrpsButL /* all groups list but last one (cf. GrpList: all groups) */
    LastGrpF /* stand-in name for dataset with frequencies of last group */
    LastGrpN /* name of temporary variable representing number of observations */
    LastGrpL /* overall number of levels (to present) of last group */
    ;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Initialization of some alias variable and dataset names;
%*________________________________________________________;

  %LET Contents = __contDs;
  %LET XtabData = __xTabDs;
  %LET AggrPart = __partDs;
  %LET AggrData = __dataDs;
  %LET Grp1Part = __v1Part;
  %LET Grp1Data = __v1Data;
  %LET Val0Data = __v0Data;
  %LET Constant = ___Const;
  %LET Dummy    = ___Dummy;
  %LET LastCase = ___Last ;
  %LET InclType = ___Type_;
  %LET GrpValue = ___Value;
  %LET Grp1Lvls = ___G1Lvl;
  %LET Err      = %SYSFUNC(COMPRESS(E R R O R, %STR( )));
  %LET Warn     = %SYSFUNC(COMPRESS(W A R N I N G, %STR( )));
  %LET oMissing = %SYSFUNC(GETOPTION(MISSING));
  %LET WhereObs = __Nobs__;
  %LET OrderVar = __Sort__;
  %DO i = 2 %TO 9; %LET DGroup&i = ; %END;
  %LET LastGrpF = ___LastF;
  %LET LastGrpN = ___LastN;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Fill LineLine with &LineSize underline characters for use in REPORT ;
%*_____________________________________________________________________;

  %LET oLS = %SYSFUNC(GETOPTION(LS));
  %IF ( &LineSize EQ ) %THEN %LET LineSize = &oLS;
  %LET LineLen = &LineSize;
  %LET LineLine = %SYSFUNC(REPEAT(_,%EVAL(&LineLen-1)));
  %IF ( &TblWidth EQ ) %THEN %LET TblWidth = &LineSize;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Keep capitalized first character in deduced macro variable ;
%*____________________________________________________________;

  %LET Missing_ = ;
  %IF ( &Missings NE ) %THEN %LET Missing_ = %UPCASE(%SUBSTR(&Missings,1,1));
  %LET NinValu_ = ;
  %IF ( &NinValue NE ) %THEN %LET NinValu_ = %UPCASE(%SUBSTR(&NinValue,1,1));
  %LET Indent_ = ;
  %IF ( &Indent   NE ) %THEN %LET Indent_  = %UPCASE(%SUBSTR(&Indent,1,1));
  %LET Titles_  = &Titles ;
  %IF ( &Titles   EQ ) %THEN %LET Titles_  = 0;
  %LET ByGrpUs_ = ;
  %IF ( &ByGrpUse NE ) %THEN %LET ByGrpUs_ = %UPCASE(%SUBSTR(&ByGrpUse,1,1));
  %IF ( &ByGrpUs_ NE T AND &ByGrpUs_ NE F ) %THEN %LET ByGrpUs_ = B;

%* ByGroups dependent fill of ByVarLst with all BY-variables and asterisks;
  %LET ByVarLst = ;
  %IF ( &ByGroups NE AND ( &ByGrpUs_ EQ T OR &ByGrpUs_ EQ F )) %THEN %DO;
    %LET i = 1;
    %LET GrpName = %SCAN(&ByGroups, &i, %STR( ));
    %DO %WHILE (&GrpName NE);
      %LET ByVarLst = &ByVarLst &GrpName * ;
      %LET i = %EVAL( &i + 1 );
      %LET GrpName = %SCAN(&ByGroups, &i, %STR( ));
    %END; %*=== While;
  %END; %* --- creating ByVarLst with asterisk separators;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* ODS argument processing: if ANY value then permanently switch off LISTING
* and temporary switch of all other destinations.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
  %IF (%LENGTH(&ODS)) %THEN %DO;
    ODS LISTING CLOSE;
    ODS EXCLUDE ALL; %* works correctly from EG (unlike ODS dest EXCLUDE ALL);
  %END;

%*~~~~~~~~~;
%* Options ;
%*_________;

/*=========
  %IF ( &LineSize NE ) %THEN OPTIONS LineSize = &LineSize;; %* PageSize not used;
=========*/
  OPTIONS MISSING='.'; %* Force numerical missings to get output as a period;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Check arguments for legal contents and discrepancies, calling e_r_r_o_r_s   ;
%*_____________________________________________________________________________;

  DATA _NULL_;
    DelList = ',; |' || BYTE(13) || BYTE(12) || BYTE(11) || BYTE (10) || BYTE(9);
    CALL SYMPUT ('DelList', DelList);
  RUN;
  %LET DelList = %QUOTE(&DelList);

  %LET ErrCount = 0;
  %IF ( &Data EQ ) %THEN %DO;
    %PUT *** &MacName *** &ERR: Dataset not specified, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- &Data empty;

  %ELSE %IF ( %SYSFUNC(EXIST(&Data)) EQ 0 ) %THEN %DO;
    %PUT *** &MacName *** &ERR: Dataset &Data does not exist,;
    %PUT                      macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
%* See also SAS Guide to macro processing, vs. 6, 2nd ed. p. 265: macro Exist;
  %END; %* --- &Data does not exist;

  %ELSE %DO; %* Check for non-existing variables within dataset;
    %ChkVar (Data=&Data, CalledBy=&MacName, VarList=&Weight
       &Group1 &Group2 &Group3 &Group4 &Group5 &Group6 &Group7 &Group8 &Group9,
             Result = ErrCount); %* adding up non-existent variables ;
  %END; %* --- check existence of variables;

  %IF ( &Group1 EQ ) %THEN %DO;
    %PUT *** &MacName *** &ERR: Group1 not specified, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- First group parameter empty;

  %DO i = 2 %TO &N_Groups-1;
    %LET j = %EVAL ( &i + 1 );
    %IF ( &&Group&j NE AND &&Group&i EQ ) %THEN %DO;
      %PUT *** &MacName *** &ERR: Group&j specified without Group&i, macro &MacName will abort;
      %LET ErrCount = %EVAL ( &ErrCount + 1);
    %END; %* --- higher numbered group specified without lower numbered group;
  %END; %* --- for Group2 and higher until last but one group .........;

  %DO i = 2 %TO &N_Dimens;
    %IF ( &&Group&i EQ AND &&Format&i NE ) %THEN %DO;
      %PUT *** &MacName *** &WARN: Format&i specified without Group&i, macro &MacName will continue;
      %LET Format&i = ; %* gets modified here;
    %END; %* --- format without group;
  %END; %* --- for Group2 and higher until last group .........;

  %IF (%SYSFUNC(VERIFY(&Titles,'0123456789'))) %THEN %DO;
    %PUT *** &MacName *** &WARN: Illegal Titles argument, should be 0..10, 0 assumed,;
    %PUT macro &MacName will continue;
  %END; %* --- check for digits;

  %DO i = 1 %TO &N_Groups;
    %DO j = &i+1 %TO &N_Groups;
      %IF ( %UPCASE(&&Group&i) EQ %UPCASE(&&Group&j) ) %THEN %DO;
        %PUT *** &MacName *** &ERR: Group&j &&Group&j equal to Group&i &&Group&i,;
        %PUT macro &MacName will abort;
        %LET ErrCount = %EVAL ( &ErrCount + 1);
      %END; %* --- equivalence between group i and j;
    %END; %* --- loop j from i+1 to &N_Groups;
  %END; %* --- loop i from 1 to &N_Groups;

  %IF ( &LineSize LT 64 OR &LineSize GT 256 ) %THEN %DO;
    %PUT *** &MacName *** &ERR: LineSize out of range 64..256, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- LineSize check;

  %IF ( &TblWidth LT 1 OR &TblWidth GT &LineSize )%THEN %DO;
    %PUT *** &MacName *** &ERR: TblWidth out of range 1..&LineSize, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- PageSize check;

  %IF (%LENGTH(%SYSFUNC(SCANQ(&Weight,2,&DelList)))) %THEN %DO;
    %PUT *** &MacName *** &ERR: more than one Weight variable, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- check for more than obe Weight variable;

*------------------------------------------------;
* Check and process Across dependent on N_Groups ;
*------------------------------------------------;
  %IF ( %UPCASE(&Across) EQ AUTO OR %UPCASE(&Across) EQ A ) %THEN %DO;
    %IF ( &N_Groups EQ 1 ) %THEN %LET Across = 0;
    %ELSE %LET Across = -1; %* last group variable values horizontally;
  %END; %* --- check Across value AUTO;
  %ELSE %IF ( %UPCASE(&Across) EQ YES OR %UPCASE(&Across) EQ Y ) %THEN
    %LET Across = 1;
  %ELSE %IF ( %UPCASE(&Across) EQ NO OR %UPCASE(&Across) EQ N OR &Across EQ ) %THEN
    %LET Across = 0;
  %ELSE %IF ( %LENGTH(%SYSFUNC(COMPRESS(&Across, 9876543210-)))) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Across argument: &Across,;
    %PUT should be (-)integer, Yes, No, Auto or empty, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* check for illegal Across values;
  %ELSE %IF ( %FirstCh(&Across) EQ %STR(-) AND
   %LENGTH(&Across, 9876543210) EQ 1 ) %THEN %DO; /* (8/8-06) */
    %PUT *** &MacName *** &ERR: Illegal Across argument: &Across only,;
    %PUT should be (-)integer, Yes, No, Auto or empty, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* check for illegal, negative Across values;
/*vvvvvvvvv (21/7-06 + 8/8-06)
  %ELSE %IF (%SYSFUNC(ABS(&Across)) GT &N_Groups) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Across argument, should absolutely be;
    %PUT LE NofGroups, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* interpretation of negative Across after NewPage and Separation below;
^^^^^^^^^*/

*------------------------------------------------------------;
* Check and process NewPage dependent on N_Groups and Across ;
*------------------------------------------------------------;
  %IF ( %UPCASE(&NewPage) EQ AUTO OR %UPCASE(&NewPage) EQ A ) %THEN %DO;
    %IF       ( &N_Groups LE 2 ) %THEN %LET NewPage = 0;
    %ELSE %IF ( &N_Groups EQ 3 AND &Across NE 0 ) %THEN %LET NewPage = 0;
    %ELSE %IF ( &N_Groups EQ 3 AND &Across EQ 0 ) %THEN %LET NewPage = 1;
    %ELSE %IF ( &Across LT 0 ) %THEN %LET NewPage = -4;
    %ELSE %LET NewPage = -3; %* new page after last but 2nd column;
  %END;
  %ELSE %IF ( &NewPage EQ ) %THEN %LET NewPage = 0;
  %ELSE %IF ( %LENGTH(%SYSFUNC(COMPRESS(&NewPage, 9876543210-)))) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal NewPage argument, should be (-)0..9,;
    %PUT Auto or empty, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF ( %FirstCh(&NewPage) EQ %STR(-) AND
    %LENGTH(%SYSFUNC(COMPRESS(&NewPage, 987654321))) NE 1 ) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal NewPage argument, should be (-)0..9,;
    %PUT Auto or empty, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF (%SYSFUNC(ABS(&NewPage)) GT &N_Groups AND &Across EQ 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal NewPage argument, should absolutely be;
    %PUT LE NofGroups, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF ((&NewPage GT &N_Groups OR &NewPage EQ 1 OR
              &NewPage LT %EVAL(-&N_Groups+1)) AND &Across GT 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal NewPage argument, should absolutely be;
    %PUT LE NofGroups and not indicate Across group, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF ((&NewPage GT %EVAL(&N_Groups-1) OR &NewPage EQ -1 OR
              &NewPage LT %EVAL(-&N_Groups)) AND &Across LT 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal NewPage argument, should absolutely be;
    %PUT LE NofGroups and not indicate Across group, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;

*---------------------------------------------------------------------------;
* Check and process Separate dependent on N_Groups and Across, like NewPage ;
*---------------------------------------------------------------------------;
  %IF ( %UPCASE(&Separate) EQ AUTO OR %UPCASE(&Separate) EQ A ) %THEN %DO;
    %IF       ( &N_Groups EQ 1 ) %THEN %LET Separate = 0;
    %ELSE %IF ( &N_Groups EQ 2 AND &Across NE 0 ) %THEN %LET Separate = 0;
    %ELSE %IF ( &N_Groups EQ 2 AND &Across EQ 0 ) %THEN %LET Separate = 1;
    %ELSE %IF ( &Across LT 0 ) %THEN %LET Separate = -3;
    %ELSE %LET Separate = -2; %* separation line after last but 1st column;
  %END;
  %ELSE %IF ( &Separate EQ ) %THEN %LET Separate = 0;
  %ELSE %IF ( %LENGTH(%SYSFUNC(COMPRESS(&Separate, 9876543210-)))) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Separate argument, should be (-)0..9,;
    %PUT Auto or empty, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF ( %FirstCh(&Separate) EQ %STR(-) AND
    %LENGTH(%SYSFUNC(COMPRESS(&Separate, 987654321))) NE 1 ) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Separate argument, should be (-)0..9,;
    %PUT Auto or empty, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF (%SYSFUNC(ABS(&Separate)) GT &N_Groups AND &Across EQ 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Separate argument, should absolutely be;
    %PUT LE NofGroups, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF ((&Separate GT &N_Groups OR &Separate EQ 1 OR
              &Separate LT %EVAL(-&N_Groups+1)) AND &Across GT 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Separate argument, should absolutely be;
    %PUT LE NofGroups and not indicate Across group, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF ((&Separate GT %EVAL(&N_Groups-1) OR &Separate EQ -1 OR
              &Separate LT %EVAL(-&N_Groups)) AND &Across LT 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Separate argument, should absolutely be;
    %PUT LE NofGroups and not indicate Across group, macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;

/* @@@@@@@@@ possible relation between NewPage and Separate NOCHECK @@@@@@@@@ */

*---------------------------------------------------------------------------;
* Check and process space separated values of ColPcRef: either a single     ;
* numerical value or an existing variable name and a quoted column label,   ;
* like in: <ColPcRef= AcrossGroupTotal "Column %">.                         ;
*---------------------------------------------------------------------------;

  %LET CpRefVar = %SYSFUNC(SCANQ(&ColPcRef,1,%STR( )));
  %LET CpRefLbl = %SYSFUNC(SCANQ(&ColPcRef,2,%STR( )));
%* Check legal empty specification, if not empty then continue checks below;
  %IF (NOT %LENGTH(%SUPERQ(ColPcRef))) %THEN /* OK, below it has been specified */;
%* Check specified elements, first and optional second (extraneous ones not checked);

%* First element of ColPcRef: CpRefVar, a numerical value or an existing variable name;
  %ELSE %IF (NOT %SYSFUNC(VERIFY(&CpRefVar,'-.0123456789E'))
    AND %UPCASE(%SUBSTR(&CpRefVar,1,1)) NE E) %THEN %DO;
    %LET CpRefVal = &CpRefVar; /* OK, numerical value */ %LET CpRefVar = /* empty */;
  %END; %* --- above situation is legal, if no numerical value then continue checks;
%* Now variable name assumed: check for valid SAS name or rather for existence;
  %ELSE %IF (%ChkExist(Data=&Data, VarList=&CpRefVar, CalledBy=CrossTab)) %THEN %DO;
    %PUT *** &MacName *** &ERR: First argument value of ColPcRef:&CpRefVar;
    %PUT is neither a numerical value nor an existing variable name;
    %PUT Macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;

%* First element of &ColPcRef has been specified, if second one empty then define default;
  %IF (%LENGTH(%SUPERQ(CpRefVar)) OR %LENGTH(%SUPERQ(CpRefVal))) %THEN %DO;
    %IF (NOT %LENGTH(%SUPERQ(CpRefLbl))) %THEN %LET CpRefLbl = "COL%"; %* default;
%* Optional second element of ColPcRef: CpRefLbl, must start with a normal quote;
    %ELSE %IF ( %QSUBSTR(&CpRefLbl,1,1) NE %STR(%")
      AND %QSUBSTR(&CpRefLbl,1,1) NE %STR(%') ) %THEN %DO;
      %PUT *** &MacName *** &ERR: Second argument value of ColPcRef: &CpRefLbl;
      %PUT not specified within (normal) quotes, must be, macro &MacName will abort;
      %LET ErrCount = %EVAL ( &ErrCount + 1);
    %END; %* --- [2nd element of &ColPcRef];
  %END; %* --- [First element specified];

%* Width1st;
  %IF (NOT %LENGTH(%SUPERQ(Width1st))) %THEN /* empty */ ;
  %ELSE %IF (%SYSFUNC(VERIFY(&Width1st,'0123456789'))) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Width1st=&Width1st argument, should be numeric;
    %PUT Macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- Width1st not numeric;
  %ELSE %IF (&Width1st EQ 0) %THEN %DO;
    %PUT *** &MacName *** &ERR: Illegal Width1st argument, 0 not allowed;
    %PUT Macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END; %* --- Width1st = 0;

%* Out and Overwrit;
  %IF (NOT (%UstrMcmp(&Overwrit,YES) OR %UstrMcmp(&Overwrit,NO))
    AND %LENGTH(%SUPERQ(Overwrit))) %THEN %DO;
    %PUT *** &MacName *** &ERR: Overwrit argument illegal: &Overwrit,;
    %PUT .                macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF (%LENGTH(%SUPERQ(Out)) AND %SYSFUNC(EXIST(&Out))
    AND NOT %UstrMcmp(&OverWrit,YES)) %THEN %DO;
    %PUT *** &MacName *** &ERR: Dataset Out=&Out exists and OverWrit is not Y[es],;
    %PUT                  macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF (%LENGTH(%SUPERQ(Out)) AND %LENGTH(%SUPERQ(ByGroups))) %THEN %DO;
    %PUT *** &MacName *** &ERR: both Dataset Out and ByGroups specified,;
    %PUT .                Output data set cannot be created for BY groups,;
    %PUT .                macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;

%* Out2 and Ovrwrit2;
  %IF (NOT (%UstrMcmp(&Ovrwrit2,YES) OR %UstrMcmp(&Ovrwrit2,NO))
    AND %LENGTH(%SUPERQ(Ovrwrit2))) %THEN %DO;
    %PUT *** &MacName *** &ERR: Ovrwrit2 argument illegal: &Ovrwrit2,;
    %PUT .                macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;
  %ELSE %IF (%LENGTH(%SUPERQ(Out2)) AND %SYSFUNC(EXIST(&Out2)) 
    AND NOT %UstrMcmp(&Ovrwrit2,YES)) %THEN %DO;
    %PUT *** &MacName *** &ERR: Dataset Out2=&Out2 exists and Ovrwrit2 is not Y[es],;
    %PUT                  macro &MacName will abort;
    %LET ErrCount = %EVAL ( &ErrCount + 1);
  %END;

%* No detailed checks on textual or numerical contents of arguments necessary;
  %IF ( &ErrCount GT 0 ) %THEN %GOTO Interupt;
%* -------------------------------end-of-checks------------------------------- ;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Recode old values of Across and make last group first if Across < 0 ;
%*_____________________________________________________________________;

%* If Across is negative the last specified group variable should be the column
%* variable instead of the first one: exchange (shift) group arguments;
%* (Recursive recall not necessary);

  %IF &Across LT 0 %THEN %DO;
    %LET Grp1Var  = &&Group&N_Groups;
    %LET GrpFmt1  = &&Format&N_Groups;
    %LET Grp1Type = &&Missing&N_Groups;
    %LET Grp1Lbl  = &&Total&N_Groups;
    %LET Value    = &&Values&N_Groups;
    %LET Order    = &&Order&N_Groups;
    %DO i = &N_Groups %TO 2 %BY -1;
      %LET j = %EVAL ( &i - 1 ) ;
      %LET Group&i = &&Group&j;
      %LET Format&i = &&Format&j;
      %LET Missing&i = &&Missing&j;
      %LET Total&i = &&Total&j;
      %LET Values&i = &&Values&j;
      %LET Order&i = &&Order&j;
    %END; %* --- reorder Group# variable names with negative Across;
    %LET Group1 = &Grp1Var;
    %LET Format1 = &GrpFmt1;
    %LET Missing1 = &Grp1Type;
    %LET Total1 = &Grp1Lbl;
    %LET Values1 = &Value;
    %LET Order1 = &Order;
    %LET Across = %EVAL ( -&Across ) ;

    %IF (&NewPage GT 0) %THEN %LET NewPage = %EVAL ( &NewPage + 1 );
    %ELSE %IF (&NewPage LT 0) %THEN %LET NewPage = %EVAL(&N_Groups+&NewPage+2);
    %IF (&Separate GT 0) %THEN %LET Separate = %EVAL ( &Separate + 1 );
    %ELSE %IF (&Separate LT 0) %THEN %LET Separate = %EVAL(&N_Groups+&Separate+2);
  %END; %* --- negative Across;
  %ELSE %DO; %* --- positive or zero Across;
%* Calculate absolute Newpage and Separate from negative one (subtract + 1);
    %IF (&NewPage LT 0) %THEN %LET NewPage = %EVAL(&N_Groups+&NewPage+1);
    %IF (&Separate LT 0) %THEN %LET Separate = %EVAL(&N_Groups+&Separate+1);
  %END; %* --- positive or zero Across;

%* from here on both Across, NewPage and Separate are 0 or positive! ;

%*~~~~~~~~~~~~~~~~~~;
%* Necessary format ;
%*__________________;

  PROC FORMAT;
    VALUE _Pct4_
    100 <- HIGH = "ill."
    100         = "100."
    10  -< 100  = [F4.1]
    1   -< 10   = [F4.2]  /* of alles eenvoudig F4.3 */
    0   -< 1    = [F4.3]
    LOW -< 0    = "neg."
    ;
  RUN;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Macro actually starts here ;
%*____________________________;

  %LET GrpList = &Group1 &Group2 &Group3 &Group4 &Group5 &Group6 &Group7 &Group8
                 &Group9;
  %LET GrpFmLst= Grp1Fmt Grp2Fmt Grp3Fmt Grp4Fmt Grp5Fmt Grp6Fmt Grp7Fmt Grp8Fmt
                 Grp9Fmt;     %* (allows for empty formats) ;

  %LET GrpsButL = ; %* (Related to ColPcRef argument);
  %DO I = 1 %TO &N_Groups-1; %* Build group variable list, except last group;
    %LET GrpsButL = &GrpsButL &&Group&I;
  %END;

  %IF ( %FirstCh(&LineSpac) EQ S OR %LENGTH(&ODS)) %THEN %LET LineSkip = ;
  %ELSE %LET LineSkip = SKIP;

%* Redefine NinValu_ if Auto, dependent on Across;
  %IF ( &NinValu_ EQ A ) %THEN %DO;
    %IF ( &Missing_ EQ E OR &Total1 EQ ) %THEN %LET NinValu_ = Y;
    %ELSE                                      %LET NinValu_ = N;
  %END; %* --- NinValue=Auto;

%* Make copies of format macro variables: copy Format# to Grp#Fmt ;
  %DO i = 1 %TO &N_Groups;
    %LET Grp&i.Fmt = %UPCASE(&&Format&i);
  %END; %* --- assign formats to Grp#Fmt for all groups;
  /* @@@@@@@@@ this might be redundant, see whether can be removed */

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Determine characteristics (type, format, label) of group variables ;
%*____________________________________________________________________;

  PROC CONTENTS DATA=&Data OUT=&Contents NOPRINT; RUN;
  DATA _NULL_;
    LENGTH Format $16;
    SET &Contents (KEEP=Name Type Length Format FormatL FormatD Label);
    %DO i = 1 %TO &N_Groups;
      IF ( UPCASE(Name)=UPCASE("&&Group&i") ) THEN DO;
 /* 1 = Numerical, 2 = Character */
%* make macro variable for group variable type;
        CALL SYMPUT ("Grp&i.Type", TRIM(LEFT(PUT(Type,1.0))));
%* make macro variable for group variable length;
        CALL SYMPUT ("Grp&i.Len", TRIM(LEFT(PUT(Length,5.0)))); * [21nov2013];
%* make macro variable for group variable format, even if not defined, empty;
        IF ( Format NE ' ' AND FormatL EQ 0 ) THEN
          Format = TRIM(LEFT(Format)) || '.';
        ELSE IF ( FormatL NE 0 ) THEN DO;
          Format = TRIM(LEFT(Format)) || TRIM(LEFT(PUT(FormatL,BEST5.))) || '.'
                                      || TRIM(LEFT(PUT(FormatD,BEST5.))) ;
        END;
        CALL SYMPUT ("GrpFmt&i", TRIM(LEFT(Format)));
%* make macro variable for group variable label, if not defined: variable name;
        IF ( Label NE ' ' ) THEN Grp&i.Lbl = Label;
        ELSE Grp&i.Lbl = Name;
        CALL SYMPUT ("Grp&i.Lbl", TRIM(LEFT(Grp&i.Lbl)));
      END; %* --- match between Name and Group#;
   %END; %* --- for all groups;
  RUN; %* --- DATA _NULL_;

  PROC DATASETS; DELETE &Contents; QUIT;

  %DO i = 1 %TO &N_Groups;
    %IF (&&Grp&i.Fmt EQ AND &&GrpFmt&i NE) %THEN %LET Grp&i.Fmt = &&GrpFmt&i;
    %ELSE %IF ( &&Grp&i.Fmt NE AND &&Grp&i.Fmt NE UNFORMATTED ) %THEN %DO;
      %IF ( ( &&Grp&i.Type EQ 1 AND %SUBSTR(&&Grp&i.Fmt,1,1) EQ $) OR
          ( &&Grp&i.Type EQ 2 AND %SUBSTR(&&Grp&i.Fmt,1,1) NE $) ) %THEN %DO;
        %PUT *** &MacName *** &ERR: Specified format &&Grp&i.Fmt and existing variable;
        %PUT type &&Grp&i.Type do not match for Group&i=&&Group&i, macro &MacName will abort;
        %LET ErrCount = %EVAL ( &ErrCount + 1);
      %END; %* --- if non-matching format for variable;
    %END; %* --- if format specified for group;
  %END; %* --- for all groups;
  %IF ( &ErrCount GT 0 ) %THEN %GOTO Interupt;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Throw away any missing value for Group1 .. Group9 if it is missing ;
%*____________________________________________________________________;

%*put ***DEBUG*** Outputting XtabData including CpRefVar variable; %* DEBUG;

  DATA &XtabData (KEEP=&GrpList &ByGroups &CpRefVar &Weight);
    %IF (%STR(&NoTable) NE ) %THEN %DO;
* Investigate whether 0 obs (after WHERE selection);
      IF (_N_ EQ 1) THEN &WhereObs = 0;
*     PUT &WhereObs=;
      CALL SYMPUT ("WhereObs", PUT(&WhereObs, BEST12.)); * for every obs;
    %END; %* --- if &NoTable specified;
    SET &Data %IF (%LENGTH(%SUPERQ(Where))) %THEN (WHERE=(%UNQUOTE(&Where))); ; %* [30apr2014] ;
* Remaining of data step not run if no observations;
    %IF (%STR(&NoTable) NE ) %THEN &WhereObs + 1;;

    %DO i = 1 %TO &N_Groups;
      %IF ( &&Grp&i.Type EQ 1 ) %THEN %LET Grp&i.1st = %STR(_);
      %ELSE %LET Grp&i.1st = %STR($);

      %IF ( &&Grp&i.Fmt EQ UNFORMATTED ) %THEN %DO;
        FORMAT &&Group&i ;
        %LET Grp&i.Fmt = ;
      %END; %* --- if UNFORMATTED then remove possibly associated format;

      %IF ( &&Missing&i EQ ) %THEN %DO;
        IF ( MISSING(&&Group&i) ) THEN DELETE; %* delete "missing" record;
      %END; %* --- if Missing# specified;
    %END; %* --- for all groups;
  RUN; %* DATA XtabData;

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.XtabData; SET &XtabData; RUN;
  %END;

%* --------- Process empty dataset ---------;
  %IF (%STR(&NoTable) NE ) %THEN %DO;
    %IF (&WhereObs EQ 0) %THEN %DO;
      %IF (%FirstCh(&NoTable) NE %STR(%')) %THEN
        %LET NoTable = %QSYSFUNC ( TRANWRD ( %QUOTE(&NoTable), $, %STR(&) ) );
  %*put @@@@@@@@ NoTable=&NoTable; %* @@@@@@@@@ macro N0cases? ;
      DATA &Dummy;
        Message = %UNQUOTE(&NoTable);
        PUT Message=;
      RUN;

      %IF (%LENGTH(&ODS)) %THEN ODS SELECT ALL;;
      PROC REPORT DATA=&Dummy; RUN;
      %IF (%LENGTH(&ODS)) %THEN ODS EXCLUDE ALL;;
      %GOTO Finish;
    %END; %* --- if empty dataset;
  %END; %* --- if NoTable specified (default);

%* If percentage reference specified, create reference dataset from XtabData;
%* @@@@@@@@@ macro named dataset @@@@@@@@@ if not numeric @@@@@@@@;
%*put ***DEBUG*** sorting XtabData class variables into __PctRef and making unique;
  %IF (%LENGTH(%SUPERQ(CpRefVar))) %THEN %DO;
/* @@@@@@@@@ no sort here by formatted by-group variables, possibly to do */
/* or to exclude / possibly remember sort order by generating initial variable */
/* with sorting order in XtabData: ___Order @@@@@@@@@ */
    PROC SORT DATA=&XtabData (KEEP=&ByGroups /*&GrpsButL*/&GrpList &CpRefVar)
               OUT=__PctRef NODUPKEY; * one record per value combination;
      BY &ByGroups /*&GrpsButL*/&GrpList; * all class variables, but last one for which pct;
    RUN;
 %END; %* --- if CpRefVar specified [then sort unique class records of XtabData] ;

%*------------------------------- R E P O R T ---------------------------------;

%* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ;
%* The below total and missing values may be adapted to include higher ascii ;
%* values, while taking care of a higher value for Missing than for Total,   ;
%* causing the Missing category to occur below or after the Total category.  ;
%* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ;
  %IF ( &Missing_ NE E ) %THEN %DO;
    %LET NumTotal = 999999999;
    %LET ChrTotal = '~';
    %LET NumMis   = ;
    %LET ChrMis   = ;
  %END; %* --- if &Missing_ NE E;
  %ELSE %DO; %* Missing_=E;
    %LET NumTotal = 999999998;
    %LET ChrTotal = '}';
    %LET NumMis   = 999999999;
    %LET ChrMis   = '~';
  %END; %* --- if Missing_=E;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Make additional numeric and char. format for missing and total group values ;
%*_____________________________________________________________________________;

  %LET i = 1;
  %LET GrpName = %SCAN(&GrpList, &i, %STR( ));
  %DO %WHILE (&GrpName NE);

    %LET FmtName = &&Grp&i.1st.__&i.Fmt;
    %if &debug %then; %put DEBUG FMTNAME I=&I, FmtName=&FmtName;
    PROC FORMAT; * Add formats for missings and total values for groups;
      VALUE &FmtName
      %IF ( &&Grp&i.Type EQ 1 ) /* numeric type */ %THEN %DO;
        %IF ( %LENGTH(&&Missing&i) ) %THEN %DO;
          ._ - .z = &&Missing&i /* whole missing range, maybe per missing value */
          %IF ( &NumMis NE ) %THEN %STR(&NumMis = &&Missing&i);
        %END; %* --- if Missing# specified;
        %IF ( &&Total&i NE ) %THEN %STR(&NumTotal = &&Total&i); %* total value ;
      %END; %* --- [numeric type];
      %ELSE %DO; %* character type ;
        %IF ( %LENGTH(&&Missing&i) ) %THEN %DO;
          ' ' = &&Missing&i
          %IF ( &ChrMis NE ) %THEN %STR(&ChrMis = &&Missing&i);
        %END; %* --- if Missing# specified;
        %IF ( &&Total&i NE ) %THEN %STR(&ChrTotal = &&Total&i); %* total value ;
      %END; %* --- [character type];

      %IF ( %UNQUOTE(%NRSTR(&)%SCAN(&GrpFmLst, &i, %STR( ))) NE ) %THEN %DO;
%if &debug %then %put DEBUG OTHER GrpFmLst=&GrpFmLst, I=&I;
        OTHER = [%UNQUOTE(%NRSTR(&)%SCAN(&GrpFmLst, &i, %STR( )))]
/*--------- (this does the same, but does not make use of a list)
      %IF ( &&Grp&i.Fmt NE ) %THEN %DO;
        OTHER = [&&Grp&i.Fmt]
---------*/
      %END; %* --- if numeric Group format specified [then add that to OTHER];
      %ELSE %IF ( &&Grp&i.Type EQ 2 ) %THEN %DO;
/* This allows for longer character values than 8 */
        OTHER = [$CHAR&&Grp&i.Len.]
      %END; %* --- if character Group format specified [then add that to OTHER];
      ;
    RUN; %* --- [PROC FORMAT];

%* rename macro variable to point to new format;
    %LET /*Grp&i.Fmt*/ %SCAN(&GrpFmLst, &i, %STR( )) = &FmtName..;

    %LET i = %EVAL( &i + 1 );
    %LET GrpName = %SCAN(&GrpList, &i, %STR( ));
  %END; %* === While --- for all specified groups;

%* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ;

  %LET Grp1Var  = __Group1;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Calculate all category statistics: numbers and percentages, into a dataset ;
%*____________________________________________________________________________;

%Recalc:

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* SORT if ByGroups specified ;
%*____________________________;

  %IF ( &ByGroups NE AND ( &ByGrpUs_ EQ B OR &Missing_ EQ X ) ) %THEN %DO; %* BY;
    PROC SORT DATA=&XtabData; BY &ByGroups; RUN;
%* This actually should be some sort according to _formatted_ BY-variables;
  %END; %* --- if ByGroups specified and ByGrpUse=B or Missing=X [then sort];

  %ELSE %IF ( &ByGroups NE AND &ByGrpUs_ EQ F ) %THEN %DO; %* ByGrpUse=FREQ;
    PROC FREQ DATA=&XtabData;
      %DO j = 1 %TO &N_Groups;
        %IF ( &&Grp&j.Fmt NE ) %THEN %STR(FORMAT &&Group&j &&Grp&j.Fmt;); %*Formats;
      %END; %* --- for all groups;
      %LET Request = &Group1 ;
      %DO i = 2 %TO &N_Groups;
        %LET Request = &Request * &&Group&i;
      %END; %* --- for all groups except first one;
      %IF ( &Missing_ EQ X ) %THEN %DO;
/*      %LET Request = &Request * _TYPE_; %* add;*/
      %END; %* --- [if Missing_ = X];

* PROC FREQ continued .........;
      TABLES &ByVarLst &Request / NOPRINT NOPERCENT OUT=&AggrData
/* Never force SPARSE below as this might result in one or more BY-groups with
 * 0-counts only, resulting in a severe   e r r o r:  unknown exception.
 *//* %IF ( &Missing_ EQ X AND %FirstCh(&ZeroFreq) EQ Y ) %THEN SPARSE; */
      %IF ( &Missing_ EQ I ) %THEN MISSING; ;
      %IF ( &Missing_ EQ X ) %THEN %STR(WEIGHT Count /*&Weight*/;); %* @@@@@@@@@?;
/*    %ELSE %IF (%LENGTH(&Weight)) %THEN %STR(WEIGHT &Weight;); */ %* @@@@@@@@@?;
/* === REMOVE THIS CODE ONCE ENTIRELY CLEAR IT IS REDUNDANT === */
    RUN; %* --- [PROC FREQ];

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_Freq1; SET &AggrData; RUN;
    DATA Current.XtabData_Freq1; SET &XtabData; RUN;
  %END;

    PROC DATASETS; DELETE &XtabData; RUN; QUIT; %* Delete &XtabData;

%* Original BY-Variables now sorted according to formatted values;
    DATA &XtabData; SET &AggrData; RUN;    %* Copy &AggrData to &XtabData;
    PROC DATASETS; DELETE &AggrData; RUN; QUIT; %* Delete &AggrData;
  %END; %* --- [ByGrpUse=FREQ];

  DATA &XtabData;
    SET &XtabData;
    &Constant = 1; %* Create variable with single value and calculate statistics;
/*  %IF (&Missing_ EQ X AND %LENGTH(&Weight)) %THEN %DO;
      Count = Count * &Weight;
    %END;
=== REMOVE THIS CODE ONCE ENTIRELY CLEAR IT IS REDUNDANT === */
  RUN; %* --- [&XtabData];

/*data current.xtabdata; set &xtabdata; run; ********* DEBUG debug D E B U G d*e*b*u*g ;*/

%*Build all combinations of requests: (crossing of) max 32 grouping variable(s);
  %DO i = 2**&N_Groups-1 %TO 0 %BY -1; %* Value 0 forces &Constant for GrandTot;
    %LET Request = ;
    %LET Dimensio = 0;
    %LET ExclList = ;
    %IF ( &i = 0 ) %THEN %LET Request = &Constant; %* % else % do;
    %IF (%FirstCh(&PctAcros) EQ I AND &Across NE 0) %THEN %DO; /* 17oct 2007 */
      %LET GrpStart = &N_Groups;
      %LET GrpStop  = 1;
      %LET GrpIncr  = -1;
    %END; %* --- looping backwards [i = 2**&N_Groups-1 %TO 0 %BY -1];
    %ELSE %DO; %* looping forwards (Original);
      %LET GrpStart = 1;
      %LET GrpStop  = &N_Groups;
      %LET GrpIncr  = 1;
    %END; %* --- looping forwards;

    %DO j = &GrpStart %TO &GrpStop %BY &GrpIncr; /* 28sep2007 */
      %LET G = %EVAL( &J - (%FirstCh(&PctAcros) EQ I AND &Across NE 0) ); /* 17oct2007 */
      %IF ( &G EQ 0 ) %THEN %LET G = &N_Groups; /* 17oct2007 */
      %IF ( %SYSFUNC ( BAND (&i, 2**(&g-1)) ) GT 0 ) %THEN %DO;
%* (Group) variables in analysis;
        %IF ( %SCAN(&Request, 1, %STR( )) EQ ) %THEN %DO;
          %LET Request = &&Group&g;
          %LET Dimensio = 1;
        %END; %* --- [still empty Request];
        %ELSE %DO;
          %LET Request = &Request * &&Group&g;
          %LET Dimensio = %EVAL ( &Dimensio + 1 );
        %END; %* --- [Request being built];
      %END; %* --- [( BAND (&i, 2**(&g-1)) ) GT 0];
      %ELSE %DO; %* Make list of (group) variable numbers not in analysis;
        %LET ExclList = &ExclList &g;
      %END; %* --- [ExclList];
    %END; %* --- [build Request and Dimensio by looping];
    %*PUT ===N_Groups=&N_Groups===i=&i===Dimensio=&Dimensio===Request=&Request===;

    PROC FREQ DATA=&XtabData;
      %IF (&ByGroups NE AND ( &ByGrpUs_ EQ B OR &ByGrpUs_ EQ F ) ) %THEN
        %STR(BY &ByGroups;);
      %DO j = 1 %TO &N_Groups;
%if &debug %then %put DEBUG GrpJFmt: J=&J, GroupJ=&&Group&J, GrpJFmt=&&Grp&j.Fmt;
        %IF ( &&Grp&j.Fmt NE ) %THEN %STR(FORMAT &&Group&j &&Grp&j.Fmt;); %*Formats;
      %END; %* --- for all groups [associate specified formats];

* PROC FREQ continued .........;
      TABLES &ByVarLst &Request / NOPRINT OUT=&AggrPart
      %IF ( &Dimensio GE 2 OR ( &ByGroups NE AND &ByGrpUs_ EQ T )) %THEN
        (RENAME=(PCT_TABL=_Pct_Tbl Pct_Row=_Pct_Row Pct_Col=_Pct_Col)) OUTPCT;
      %IF ( %FirstCh(&ZeroFreq) EQ Y ) %THEN SPARSE;
      %IF ( &Missing_ EQ I ) %THEN MISSING;;
  %* option MISPRINT appears to be active always while writing OUTfile;
  %* option TOTPCT seems to have no effect at all while writing OUTfile;

      %IF ( &Missing_ EQ X ) %THEN %DO;       /* Optional second pass only */
                                              /* Aggregated output as input */
        WEIGHT Count /* incl. &Weight @@@ */; /* Aggregated cell frequency */
        WHERE ( Percent NE .                  /* Keep only non-missing cells */
          AND _TYPE_ EQ 2**&N_Groups-1 );     /* Keep cells only, no totals */
      %END; %* --- [&Missing_ EQ X];
      %ELSE %IF ( &ByGroups NE AND &ByGrpUs_ EQ F ) %THEN %STR(WEIGHT Count;);
      %ELSE %IF (%LENGTH(&Weight)) %THEN %STR(WEIGHT &Weight;);
    RUN; %* --- [PROC FREQ];

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrPart_Freq2; SET &AggrPart; RUN;
    DATA Current.XtabData_Freq2; SET &XtabData; RUN;
  %END;

/* @@@@@@@@@ sort AggrPart here too by the same variables if needed */

%*put ***DEBUG***: Before DATA AggrPart (Grp1Part), output of AggrPart;
/*data current.AggrPart; set &AggrPart; run; * debug;*/

    DATA &AggrPart
      %IF (&NinValu_ EQ Y AND &Missing_ NE X AND %LENGTH(%SUPERQ(Total1))) %THEN
        &Grp1Part (KEEP=&ByGroups &Group1 Count /* @@@@@@@@@ &CpRefVar ???*/);;
      SET &AggrPart;
%*    &Constant = 2;
      %IF ( &Dimensio LE 1 AND &N_Groups GT 1
        AND ( &ByGroups EQ OR &ByGrpUs_ EQ B OR &ByGrpUs_ EQ F ) ) %THEN %DO;
        _Pct_Row = Percent;
        _Pct_Col = Percent;
      %END; %* --- [%IF 4 lines above];

/*---------
      %IF ( &Dimensio LE 2 AND &N_Groups GT 2 ) %THEN %DO;
        _Pct_Tbl = 100; %* ?????????;
      %END; Q* --- [&Dimensio LE 2 AND &N_Groups GT 2];
---------*/

      %LET j = 1;
      %LET ExcVarNr = %SCAN(&ExclList, &j, %STR( ));
      %DO %WHILE (&ExcVarNr NE);

        %IF ( &&Grp&ExcVarNr.Type EQ 1 ) %THEN %STR(&&Group&ExcVarNr = &NumTotal;);
        %ELSE %DO; %* &&Grp&ExcVarNr.Type EQ 2;
          LENGTH &&Group&ExcVarNr $&&Grp&ExcVarNr.Len;
          %IF (&&Total&ExcVarNr NE) %THEN %STR(&&Group&ExcVarNr = &ChrTotal;);
          %***ELSE /* not to print anyway */ %STR(&&Group&ExcVarNr = '{total}';);
        %END; %* --- [&&Grp&ExcVarNr.Type EQ 2];

/*=========  en eventuele aanvullende voorwaarde ivm BY-vars in TABLE
        %IF ( &N_Groups EQ 2 ) %THEN %DO;
%* Only if there are at least 2 variables @@@;
          %IF ( &ExcVarNr EQ 1 ) %THEN %DO;
%* copy PERCENT value to _Pct_ROW value;
%*          _Pct_Row = Percent;
          %END; %* --- [&ExcVarNr = 1];
          %IF ( &ExcVarNr EQ 2 ) %THEN %DO;
%* copy PERCENT value to _Pct_COL value;
%*          _Pct_Col = Percent;
          %END; %* --- [&ExcVarNr = 2];
        %END; %* --- [&N_Groups = 2];
=========*/

        %IF ( &ExcVarNr EQ &N_Groups AND %UPCASE(%SUBSTR(&Force100,1,1)) EQ Y )
          %THEN %DO; %* if last group variable and Force100 = Y then;
          _Pct_Row = 100;
%*        _Pct_Tbl = 100;
        %END; %* --- ;

        %LET j = %EVAL( &j + 1 );
        %LET ExcVarNr = %SCAN(&ExclList, &j, %STR( ));
      %END; %* === While --- [&ExcVarNr NE ];

      %IF (&i = 0) %THEN DROP &Constant;; %* Only keep totals for (group) variables;

      _TYPE_ = &i; %* Analogue to PROC MEANS, to use with selecting subtotals;

%* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ;
%* With &i=1 or 0 this record presents a total for the concerning value of     ;
%* group 1 and the grand total.                                                ;
%* This serves as the base for a group 1 label with '(N=#)'.                   ;
%* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ;
      %IF (&NinValu_ EQ Y AND &Missing_ NE X AND &i LE 1
        AND %LENGTH(%SUPERQ(Total1))) %THEN OUTPUT &Grp1Part; ;

%* Determine which totals to delete dependent on Total#;
      &InclType = &i; %* _Type_; %* +++;
      %DO j = 1 %TO &N_Groups;
        %IF ( &&Total&j = ) %THEN %DO;
          IF (NOT BAND(&InclType, 2**(&j-1))) THEN DELETE; %* record(s) with totals;
        %END; %* --- [&&Total&j = ];
      %END; %* --- %-DO loop;
      DROP &InclType; %* or leave it in ?????????;

/*=========  and possible additional condition in relation to BY-vars in TABLE
      %IF ( &N_Groups EQ 1 ) %THEN %DO;   %* For one group variable only;
                                          %* Copy PERCENT value to _Pct_COL value;
        _Pct_Col = Percent;               %* Solved using PctCol macro variable;
      %END;
=========*/

      %IF (%FirstCh(PctAcros) NE I) %THEN %DO;
%* Because of layout and conceptual differences with FREQ/TABULATE: (conceptual)
 * rows and columns are reversed: swap row and column percentages back again;
        &Dummy = _Pct_Col;
        _Pct_Col = _Pct_Row;
        _Pct_Row = &Dummy;
        DROP &Dummy;
      %END; %* --- [%FirstCh(PctAcros) NE I];

      OUTPUT &AggrPart;
    RUN; %* -- [DATA &AggrPart];

  %IF (&Debug EQ 9) %THEN %DO;
/*  DATA Current.Grp1Part_Output; SET &Grp1Part; RUN;*/
    DATA Current.AggrPart_Output; SET &AggrPart; RUN;
  %END;

%* 'FORCE' below necessary as character variables from FREQ may have different
%* lengths as those entered;
    PROC APPEND DATA=&AggrPart OUT/*BASE*/=&AggrData FORCE;
 
  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrPart_Append; SET &AggrPart; RUN;
    DATA Current.AggrData_Append; SET &AggrData; RUN;
  %END;

   PROC DATASETS; DELETE &AggrPart; QUIT;
/*========= ???
    DATA &AggrData;
      SET %IF ( &i LT 2**&N_Groups ) %THEN &AggrData; &AggrPart;
    RUN;
=========*/

    %IF (&NinValu_ EQ Y AND &Missing_ NE X AND %LENGTH(%SUPERQ(Total1)))
      %THEN %DO;
      PROC APPEND DATA=&Grp1Part OUT/*BASE*/=&Grp1Data FORCE; RUN;
  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.Grp1Part_Append; SET &Grp1Part; RUN;
    DATA Current.Grp1Data_Append; SET &Grp1Data; RUN;
  %END;
      PROC DATASETS; DELETE &Grp1Part; RUN; QUIT;
    %END; %* --- [&NinValu_ EQ Y AND &Missing_ NE X AND %LENGTH(%SUPERQ(Total1))];

  %END; %* --- end of (long) loop: [i = 2**&N_Groups-1 %TO 0 %BY -1];

  %IF ( &Missing_ NE X ) %THEN %DO;
    PROC DATASETS; DELETE &XtabData; RUN; QUIT;
  %END; %* --- [&Missing_ NE X];

%* = = = = = = = = = P r o c e s s   C o l P c R e f = = = = = = = = =
%* Entire separate datastep to process &CpRefVar & Val percentages;
%* - - - - - - - - - E X P E R I M E N T A L - - - - - - - - - ;
  %IF (%LENGTH(%SUPERQ(ColPcRef))) %THEN %DO; %* Percentage reference specified;
%* @@@@@@@@@ and not a constant value @@@@@@@@@ delete temp __PctRef @@@@@@@@@;

    %IF (%LENGTH(%SUPERQ(CpRefVar))) %THEN %DO; %* Reference variable name in &CpRefVar;
* Presort &AggrData by &ByGroups /*&GrpsButL*/&GrpList for merging;
      PROC SORT DATA=&AggrData; BY &ByGroups /*&GrpsButL*/&GrpList; RUN;
      DATA &AggrData;
        MERGE &AggrData __PctRef; BY &ByGroups /*&GrpsButL*/&GrpList; * adding &CpRefVar variable;
/* @@@@@@@@@ with CpRefVar also make N-values in column header equal to these? */

* Calculate (column) percentage using &CpRefVar [25nov2013];
        IF (&CpRefVar EQ 0) THEN _Pct_Ref = . ;
        ELSE IF (&CpRefVar LT 0) THEN _Pct_Ref = . ;
        ELSE IF (MISSING(&CpRefVar)) THEN _Pct_Ref = . ; %* @@@@@@@@@ ;
        ELSE _Pct_Ref = 100 * Count / &CpRefVar; * Percentage calculation based on reference;
      RUN; %* --- [DATA &AggrData];
    %END; %* --- [Reference variable name in &CpRefVar];

    %ELSE %DO; %* Constant reference value in &CpRefVal;
      DATA &AggrData;
        SET &AggrData;
* Percentage calculation based on reference;
        IF (&CpRefVal GT 0) THEN _Pct_Ref = 100 * Count / &CpRefVal;
      RUN; %* --- [DATA &AggrData];
    %END; %* --- [Reference value in &CpRefVal];

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_PctRef; SET &AggrData; RUN;
    DATA Current.__PctRef; SET __PctRef; RUN;
  %END;

  %END; %* --- ColPcRef specified, (partial) processing here;
%* = = = = = = = = = E N D   C o l P c R e f = = = = = = = = =

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* End of calculation of all category statistics: numbers and percentages ;
%*________________________________________________________________________;

  %IF ( &Debug > 10 ) %THEN %DO;
/*  %IF ( &N_Groups GT 2 ) %THEN %STR(OPTIONS LINESIZE=125;); %*DBG REMOVE; */
    TITLE "Print 1 of Aggregated data, Missing_=&Missing_";    
    PROC PRINT DATA=&AggrData; RUN;
    %IF (&NinValu_ EQ Y AND &Missing_ NE X AND %LENGTH(%SUPERQ(Total1))) %THEN %DO;
      PROC PRINT DATA=&Grp1Data; TITLE "Print 1 of group 1 aggregated data";
      FORMAT &Group1; RUN;
    %END; %* --- [%IF above];
    %*IF ( &N_Groups GT 2 ) %THEN %STR(OPTIONS LINESIZE=80;);  %*DBG REMOVE;
  %END; %* --- [&Debug GT 10];

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Forcing optionally specified group values to occur in the table ;
%*_________________________________________________________________;

  %IF ( &Missing_ NE X ) %THEN %DO;
%* Do it on the (first) aggregated dataset;
    %LET SortList = ;
    %DO i = &N_Groups %TO 1 %BY -1; %*;
      %IF ( %QUOTE(&&Values&i) NE ) %THEN %DO;
        %LET SortList = ;
        %DO j = 1 %TO &N_Groups;
          %IF ( &j NE &i ) %THEN %LET SortList = &SortList &&Group&j;
        %END; %* --- looping for all groups;

%* Keep only one occurrence of &&Group&I per combination of the other groups;
        PROC SORT DATA=&AggrData OUT=&AggrPart NODUPKEY; BY &ByGroups &SortList; RUN;

        DATA &Val0Data;
          SET &AggrPart;
          Count = 0;
          Percent = 0;
          %IF ( &N_Groups GT 1 ) %THEN %DO;
            _Pct_Row = 0;
            _Pct_Col = 0;
          %END; %* --- [&N_Groups GT 1];
          %IF ( &N_Groups GT 2 ) %THEN _Pct_Tbl = 0; ;

          %LET j = 1;
          %LET Value = %SYSFUNC ( SCANQ ( &&Values&i, &j, %STR( ) ) );
          %DO %WHILE ( &Value NE );
            &&Group&i = &Value;
            &OrderVar + 1; * to remember order of specified values (=&j);
            OUTPUT;
            %LET j = %EVAL ( &j + 1 );
            %LET Value = %SYSFUNC ( SCANQ ( &&Values&i, &j, %STR( ) ) );
          %END; %* --- while &Value not empty;
        RUN; %* --- [DATA &Val0Data];

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrPart_Set; SET &AggrPart RUN;
  %END;

        PROC DATASETS; DELETE &AggrPart; QUIT;

%IF ( &Debug > 10 ) %THEN %DO;
  PROC PRINT DATA=&AggrData; TITLE "AggrData 1+2"; RUN; %* debug;
  PROC PRINT DATA=&Val0Data; TITLE "Val0Data &i"; RUN; %* debug;
%END;
        PROC SORT DATA=&Val0Data; BY &ByGroups &GrpList; RUN;
        PROC SORT DATA=&AggrData; BY &ByGroups &GrpList; RUN;
        DATA &AggrData;
          MERGE &Val0Data (IN=InVal0) &AggrData; BY &ByGroups &GrpList;
          IF (NOT InVal0) THEN &OrderVar = 99999; * last in sequence;
        RUN;

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_Merged0; SET &AggrData; RUN;
    DATA Current.Val0Data_Merged0; SET &Val0Data; RUN;
  %END;

        %IF (%LENGTH(&&Values&i)) %THEN %DO; %* Restore value order;
          PROC SORT DATA=&AggrData; BY &OrderVar; RUN;
        %END; %* --- Values# specified;

        PROC DATASETS; DELETE &Val0Data; QUIT;
      %END; %* (Values# specified for this group);
    %END; %* (for each group);

%IF ( &Debug > 10 ) %THEN %DO;
  PROC PRINT DATA=&AggrData; TITLE "AggrData after forcing values in 1st loop"; RUN; %* debug;
%END;
/*=========
    %IF ( &SortList NE ) %THEN %STR (
      PROC SORT DATA=&AggrData; BY &ByGroups &GrpList; RUN; );
=========*/
  %END; %* --- [&Missing_ NE X];

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Generate total Numbers within group1 and grand total values as a new format ;
%*_____________________________________________________________________________;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Specific algorithm using an alternative, extended format (without ByGroups) ;
%*_____________________________________________________________________________;

  %IF ( &NinValu_ EQ Y AND &Missing_ NE X AND &ByGroups EQ ) %THEN %DO;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Generate temporary FileName in TempPath for storing temporary new format ;
%*__________________________________________________________________________;

    %LET TempPath = %SYSGET(TEMP);              %* Get contents of TEMP var;
    %IF ( %QUOTE(&TempPath) NE ) %THEN %DO; %* If TEMP var with dir found;
      %IF ( %SUBSTR(&TempPath,%LENGTH(&TempPath),1) NE \ ) %THEN %DO;
        %LET TempPath = &TempPath.\;              %* Add trailing \ to dir;
      %END; %* --- ;
    %END; %* --- ;

    %DO %UNTIL ( NOT %SYSFUNC ( FILEEXIST(&TempPath.&FileName) ) );
      %LET FileName = ___%SYSFUNC(TIME()); %* Random time as FileName;
    %END; %* --- ;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Write all occurring unformatted and formatted group 1 values to scratch file;
%*_____________________________________________________________________________;

    %LET Grp1nFmt = &Grp11st.__v1Fmt;

    %IF (%SYSFUNC(EXIST(&Grp1Data))) %THEN %DO;
      FILENAME scratch "TempPath.&FileName";
      DATA _NULL_;
        SET &Grp1Data END=&LastCase;
        FILE scratch;
        LENGTH &Grp1Var $100;
        IF (_N_ = 1) THEN PUT "PROC FORMAT; VALUE &Grp1nFmt"; %* Initialize format;

        %IF ( &Grp1Type EQ 1 ) %THEN %DO;                     /* numerical type */
          IF ( MISSING(&Group1) ) THEN DO;
            &Grp1Var = '._ - .z';
            %IF ( &NumMis NE ) %THEN &Grp1Var = TRIM(&Grp1Var) || ", &NumMis"; ;
          END; %* --- [&Group1 LE .z];
          ELSE &Grp1Var = TRIM(LEFT(PUT(&Group1, BEST12.3)));
        %END; %* --- numerical type;
        %ELSE %DO;                                            /* character type */
          IF ( MISSING(&Group1) ) THEN DO;
            &Grp1Var = "' '";
            %IF ( &ChrMis NE ) %THEN &Grp1Var = TRIM(&Grp1Var) || ", &ChrMis"; ;
          END; %* --- [&Group1 EQ ' '];
          ELSE &Grp1Var = '"' || TRIM(LEFT(&Group1)) || '"';
        %END; %* --- character type;

        &Grp1Var = TRIM(&Grp1Var) || ' = "' || TRIM(LEFT(PUT(&Group1,&Grp1Fmt)));
        %IF ( &Across NE 0 ) %THEN &Grp1Var = TRIM(&Grp1Var) || "&Split";;
        &Grp1Var = TRIM(&Grp1Var) || ' (N=' || TRIM(LEFT(PUT(Count,BEST12.))) || ')"';
        PUT &Grp1Var $CHAR100.;

        IF ( &LastCase ) THEN PUT '; RUN;';            %* Close and RUN statement;
      RUN; %* --- [DATA _NULL_] writing scratch file;  %* Ready building format;
%* Run format to make it effective;
      %INCLUDE scratch;                                %* Make format effective;
/* @@@@@@@@@ can the above block be replaced by filling a macro variable or macro? */

      DATA _NULL_;
        Dummy = FDELETE ("scratch");                   %* Delete scratch file;
/* or use %SYSFUNC(FDELETE(scratch)) */
        FILE LOG;
      RUN;
      FILENAME scratch CLEAR;                          %* Release association;

%* Change reference to group 1 format;
      %LET Grp1Fmt = &Grp1nFmt.. ; %* Force Grp1Fmt to point to the new Grp1nFmt ;
    %END; %* --- [%SYSFUNC(EXIST(&Grp1Data))];
  %END; %* --- [&NinValu_ EQ Y AND &Missing_ NE X AND &ByGroups EQ ];
  %* --- Specific algorithm using an alternative, extended format (without ByGroups);

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* General algorithm using an additional character variable, with any ByGroups ;
%*_____________________________________________________________________________;
/* @@@@@@@@@ possibly buggy generation of total group if not wanted @@@@@@@@@ */
 /*%else*/ %IF (&NinValu_ EQ Y AND &Missing_ NE X
      AND %LENGTH(%SUPERQ(ByGroups)) AND %LENGTH(%SUPERQ(Total1))) %THEN %DO;
    DATA &Grp1Data;
      SET &Grp1Data;
      LENGTH &Grp1Var $100;
      %IF ( &Grp1Type EQ 1 ) %THEN %DO; %* Group 1 is numeric ;
        %IF ( &Grp1Fmt NE ) %THEN %STR( &Grp1Var=TRIM(LEFT(PUT(&Group1,&Grp1Fmt))); );
        %ELSE %STR( &Grp1Var=TRIM(LEFT(PUT(&Group1,BEST12.3))); );
%* Missing value representation depends on 'OPTIONS MISSING=' setting;
%* However, this hardly occurs, as a temporary format mostly is used;
      %END; %* --- Group 1 is numeric ;
      %ELSE %DO; %* Group 1 is character ;
        %IF ( &Grp1Fmt NE ) %THEN %STR( &Grp1Var=TRIM(LEFT(PUT(&Group1,&Grp1Fmt))); );
        %ELSE %STR( &Grp1Var=TRIM(LEFT(&Group1)); );
      %END; %* --- Group 1 is character ;
      &Grp1Var = TRIM(&Grp1Var) ||
        %IF (&Across NE 0 /*AND %LENGTH(%SUPERQ(Split))*/ ) %THEN %STR("&Split" ||);
               "(N=" || TRIM(LEFT(PUT(Count, &StatWdth..0))) || ")";
      LABEL &Grp1Var = "&Grp1Lbl";
    RUN; %* --- [DATA &Grp1Data];

    %IF (&Debug EQ 9) %THEN %DO;
      DATA Current.Grp1Data_Set; SET &Grp1Data; RUN;
    %END;
  %END; %* --- [&NinValu_ EQ Y AND &Missing_ NE X AND %LENGTH..........];

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Recalculate all statistics without the missing values if Missing_=E ;
%*_____________________________________________________________________;

  %IF ( &Missing_ EQ E ) %THEN %DO;
%* Up to now percentages do not include missings, but totals do;
%* Recalculate all statistics without all missings and merge with statistics
%* on missings later;
    DATA &XtabData; SET &AggrData; RUN;      %* Copy output to input for FREQ;
    PROC DATASETS; DELETE &AggrData; QUIT;   %* Delete AggrData for append;
    %LET Missing_ = X;                       %* Indicate second pass;
    %GOTO Recalc;                            %* Start second pass;
  %END; %* --- [&Missing_ EQ E];
  %ELSE %IF ( &Missing_ EQ X ) %THEN %DO;    %* After second pass;
%IF ( &Debug = 1 ) %THEN %DO;
  PROC PRINT DATA=&XtabData; TITLE "XtabData (AggrData from first loop)"; RUN;
  PROC PRINT DATA=&AggrData; TITLE "AggrData (AggrData from second loop)"; RUN;
/*=========
  PROC PRINT DATA=&XtabData; TITLE "XtabData (AggrData from first loop)";
    FORMAT _ALL_; RUN;
  PROC PRINT DATA=&AggrData; TITLE "AggrData (AggrData from second loop)";
    FORMAT _ALL_; RUN;
=========*/
%END;
    PROC SORT DATA=&XtabData; BY &ByGroups &GrpList; RUN;
    PROC SORT DATA=&AggrData; BY &ByGroups &GrpList; RUN;
    DATA &AggrData;                          %* Merge old and new datasets;
      MERGE &XtabData &AggrData (IN=&AggrData); BY &ByGroups &GrpList;
                                            %* into a combined final result;
%* ByGroups missing values are not handled completely with ByGrpUse=BY;
%* They are handled better with ByGrpUse=TABLE, but best with ByGrpUse=FREQ;
      IF ( Percent NE . AND &AggrData EQ 0 ) THEN DO; /*DELETE*/
        Count = 0;
        Percent = 0;
        %IF ( &N_Groups GT 1 ) %THEN %DO;
          _Pct_Row = 0;
          _Pct_Col = 0;
        %END;
        %IF ( &N_Groups GT 2 ) %THEN _Pct_Tbl = 0; ;
      END; %* --- ;
    RUN; %* --- [DATA &AggrData];

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_Merged1; SET &AggrData; RUN;
    DATA Current.XtabData_Merged1; SET &XtabData; RUN;
  %END;

    PROC DATASETS; DELETE &XtabData; RUN; QUIT;
  %END; %* --- [&Missing_ EQ E];

%IF ( &Debug = 1 ) %THEN %DO;
  PROC PRINT DATA=&AggrData; TITLE "AggrData (before sorting for merging)"; RUN;
/*=========
  PROC PRINT DATA=&AggrData; TITLE "AggrData (before sorting for merging)";
    FORMAT _ALL_; RUN;
=========*/
%END;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Determination of number of levels (incl. totals) for group 1 if Across=1 ;
%*__________________________________________________________________________;

  %IF ( &Across EQ 1 ) %THEN %DO;
    PROC FREQ DATA=&AggrData; %* Run FREQ on AggrData disregarding ByGroups;
    %IF ( &Grp1Fmt NE ) %THEN %STR(FORMAT &Group1 &Grp1Fmt;); %* Formats;
    TABLES &Group1 / NOPERCENT OUT=&Grp1Part
           %IF ( &Debug LE 0 ) %THEN NOPRINT;
         %IF ( %UstrMcmp(&Missings,Include) ) %THEN MISSING;
         %IF ( %UstrMcmp(&ZeroFreq,Yes) ) %THEN SPARSE;  ;
    RUN;

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_Freq3; SET &AggrData; RUN;
    DATA Current.Grp1Part_Freq3; SET &Grp1Part; RUN;
  %END;

    DATA _NULL_;
      IF 0 THEN SET &Grp1Part NOBS=&Grp1Lvls;
      CALL SYMPUT('Across',COMPRESS(PUT(&Grp1Lvls,8.)));
      STOP;
    RUN; %* --- [DATA _NULL_];

%* This already includes the 'total' level in the aggregated dataset;

    PROC DATASETS; DELETE &Grp1Part; RUN; QUIT;

  %END; %* --- [&Across EQ 1];

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Determination of number of levels (incl. totals) for last group ;
%*_________________________________________________________________;

  PROC FREQ DATA=&AggrData; %* Run FREQ on AggrData disregarding ByGroups;
  %IF ( &&Grp&N_Groups.Fmt NE ) %THEN %STR(FORMAT &&Group&N_Groups &&Grp&N_Groups.Fmt;); %* Formats;
  TABLES &&Group&N_Groups / NOPERCENT OUT=&LastGrpF
         %IF ( &Debug LE 0 ) %THEN NOPRINT;
         %IF ( %UstrMcmp(&Missings,Include) ) %THEN MISSING;
         %IF ( %UstrMcmp(&ZeroFreq,Yes) ) %THEN SPARSE;  ;
  RUN;

  DATA _NULL_;
    IF 0 THEN SET &LastGrpF NOBS=&LastGrpN;
    CALL SYMPUT('LastGrpL',COMPRESS(PUT(&LastGrpN,8.)));
    STOP;
  RUN; %* --- [DATA _NULL_];

%* This already includes the 'total' level in the aggregated dataset;

  PROC DATASETS; DELETE &LastGrpF; RUN; QUIT;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* This is the continuation of the second NinValu_=Y condition ;
%*_____________________________________________________________;

  %IF (&NinValu_ EQ Y AND %LENGTH(%SUPERQ(ByGroups))
                      AND %LENGTH(%SUPERQ(Total1))) %THEN %DO;
    PROC SORT DATA=&AggrData; BY &ByGroups &Group1; RUN;
    PROC SORT DATA=&Grp1Data; BY &ByGroups &Group1; RUN;

%IF ( &Debug = 1 ) %THEN %DO;
  PROC PRINT DATA=&AggrData; TITLE "AggrData (before merging Grp1Data)"; RUN;
  PROC PRINT DATA=&Grp1Data; TITLE "Grp1Data (before merging AggrData)"; RUN;
%END;

%* Merge original and extended data files;
    DATA &AggrData /*(DROP=&Group1)*/;
      MERGE &AggrData &Grp1Data (DROP=Count); BY &ByGroups &Group1;
    RUN;

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_Merged2; SET &AggrData; RUN;
    DATA Current.Grp1Data_Merged2; SET &Grp1Data; RUN;
  %END;

    %_DELETE_ (&Grp1Data);

    %LET Grp1Fmt  = &Group1;  %* Use Grp1Fmt here as temporary swap space;
    %LET Group1   = &Grp1Var; %* Define new variable as group1, modifying original;
    %LET Grp1Var  = &Grp1Fmt; %* Original variable name of Group1, temporary copy;
    %LET Grp1Fmt  = ;         %* Force new Grp1Fmt empty / redefine of Grp1Fmt;
    %LET Grp1Type = 2;        %* Indicate character variable;
    %LET Grp11st  = $;        %* Indicate character variable format name prefix;
    %LET GrpList  = &Group1 &Group2 &Group3 &Group4 &Group5 &Group6 &Group7
                    &Group8 &Group9;

%* Force logical record sequence by sorting according to all variables;
    PROC SORT DATA=&AggrData; BY &ByGroups &GrpList; RUN;

  %END; %* --- [&NinValu_ EQ Y AND %LENGTH(%SUPERQ(ByGroups))
                               AND %LENGTH(%SUPERQ(Total1))];
  %ELSE %LET Grp1Var = &Group1; %* Grp1Var now always is original Group1 name;

%IF ( &Debug EQ 1 ) %THEN %DO;
  PROC PRINT DATA=&AggrData; TITLE "AggrData (after merging Grp1Data)"; RUN;
/*=========
  PROC PRINT DATA=&AggrData; TITLE "AggrData (after merging Grp1Data)";
    FORMAT _ALL_; RUN;
=========*/
%END; %* --- &Debug = 1;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Make numeric "missing" value larger than numeric "total" value for sort ;
%*_________________________________________________________________________;

  %IF ( &Missing_ EQ X ) %THEN %DO;        /* After second pass */
    DATA &AggrData;
      SET &AggrData;
      %DO i = 1 %TO &N_Groups;
        %IF ( &&Grp&i.Type EQ 1 ) %THEN %DO;
          IF ( &&Group&i LE .z  ) THEN &&Group&i = &NumMis;
        %END; %* --- numeric;
        %ELSE %IF ( &&Grp&i.Type EQ 2  ) %THEN %DO;
          IF ( &&Group&i EQ ' ' ) THEN &&Group&i = &ChrMis;
        %END; %* --- character;
      %END; %* --- loop over all groups;
    RUN; %* --- [DATA &AggrData];
  %END; %* --- [&Missing_ EQ X ] (after second pass);
  PROC SORT DATA=&AggrData; BY &ByGroups &GrpList; RUN;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Calculate number of statistics to show (for calculation of table width) ;
%*_________________________________________________________________________;

  %LET NumStats = 0; %* Number of Statistics requested;
  %IF ( &NofCases NE ) %THEN %LET NumStats = %EVAL(&NumStats+1);
  %IF ( &TablePct NE ) %THEN %LET NumStats = %EVAL(&NumStats+1);
  %IF ( &ColPct   NE ) %THEN %LET NumStats = %EVAL(&NumStats+1);
  %IF ( &RowPct   NE ) %THEN %LET NumStats = %EVAL(&NumStats+1);
  %IF ( &TwoWyPct NE ) %THEN %LET NumStats = %EVAL(&NumStats+1);
  %IF (%LENGTH(%SUPERQ(ColPcRef))) %THEN %LET NumStats = %EVAL(&NumStats+1);

%* Generate F=format part for REPORT;
  %DO i = 1 %TO &N_Groups;
    %IF ( &&Grp&i.Fmt NE ) %THEN %LET FGrp&i.Fmt = %STR ( F=&&Grp&i.Fmt );
    %ELSE %LET FGrp&i.Fmt = ;
  %END; %* --- for all groups [generate format for REPORT;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Settings per dimension and across table ;
%*_________________________________________;

  %IF       ( &N_Groups GE 3 AND &Titles_ NE 0 ) %THEN %LET Titling  = %STR (
    TITLE&Titles_ "Dataset &Data, &GrpList category statistics";
    );
  %ELSE %IF ( &N_Groups EQ 2 AND &Titles_ NE 0 ) %THEN %LET Titling  = %STR (
    TITLE&Titles_ "Dataset &Data, &Group1 and &Group2 category statistics";
    );
  %ELSE %IF ( &N_Groups EQ 1 AND &Titles_ NE 0 ) %THEN %LET Titling  = %STR (
    TITLE&Titles_ "Dataset &Data, &Group1 category statistics";
    );

  %IF ( &N_Groups EQ 1 ) %THEN %LET PctCol = Percent ;
  %ELSE %LET PctCol = _Pct_Col ;

  %IF ( &Across EQ 0 ) %THEN %DO;
    %LET LeftVar  = 1;
    %LET VarUsage = ; %* empty  ;    %* or GROUP as well ;
    %IF ( %FirstCh(&Spacing) EQ A ) %THEN %LET Spacing = 2;
    %LET StatSize = %EVAL(&NumStats*(&StatWdth+&Spacing)); %* incl. separators;
  %END; %* --- [&Across EQ 0];
  %ELSE %DO; %* [&Across NE 0];
    %LET LeftVar  = 2;
    %LET VarUsage = GROUP       ;
    %IF ( %FirstCh(&Spacing) EQ A ) %THEN %LET Spacing = 1;
    %LET StatSize = %EVAL(&Across*&NumStats*(&StatWdth+&Spacing));
  %END; %* --- [&Across NE 0];

  %LET ClasSize = %EVAL ( &TblWidth - &StatSize );
  %LET EmptyLbl = ; %* init;
  %LET NextLbl  = ; %* init;
  %LET LblAsVal = ; %* init;
  %LET LblAsHdr = ; %* init;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Process LeftLbl argument into LeftLbl_ macro variable ;
%*_______________________________________________________;

%NewInd:
  %LET LeftLbl_ = ;
  %IF ( &LeftLbl NE ) %THEN %LET LeftLbl_ = %UPCASE(%SUBSTR(&LeftLbl,1,1));
  %IF ( &Indent_ EQ ) %THEN %LET LeftLbl_ = C;                %* no Indent_;
  %ELSE %IF ( &LeftLbl_ EQ A OR &LeftLbl_ EQ ) %THEN %DO;     %* no LeftLbl;
    %IF ( &Indent_ GE 8 )                         %THEN %LET LeftLbl_ = C;
    %ELSE %IF ( &N_Groups GT 2  )                 %THEN %LET LeftLbl_ = N;
    %ELSE %IF ( &N_Groups EQ 2 AND &Across EQ 0 ) %THEN %LET LeftLbl_ = N;
    %ELSE %IF ( &N_Groups EQ 2 AND &Across NE 0 ) %THEN %LET LeftLbl_ = V;
    %ELSE %IF ( &N_Groups EQ 1 AND &Across EQ 0 ) %THEN %LET LeftLbl_ = H;
    %ELSE %IF ( &N_Groups EQ 1 AND &Across NE 0 ) %THEN %LET LeftLbl_ = E;%*n.a.;
  %END;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* No (or automatic) Indent ;
%*__________________________;

  %IF ( &Indent_ EQ /*empty*/ OR &Indent_ EQ A ) %THEN %DO;
    %LET Spacing0 = ;
    %IF ( &N_Groups-&LeftVar+1 GT 0 ) %THEN %LET GrpWidth = %EVAL (
         (&ClasSize-(&N_Groups-&LeftVar)*&Spacing)
        /(&N_Groups-&LeftVar+1) );
    %ELSE %LET GrpWidth = &ClasSize; %* (probably) not used or ignored;
%* (GrpWidth may become truncated) ;
    %IF ( &GrpWidth LE 5 AND &Indent_ EQ A ) %THEN %DO;
      %LET Indent_ = 1;
      %GOTO NewInd;
    %END;
    %ELSE %LET Indent_ = /*empty*/ ;
    %LET PrintCol = ; %* Empty;
    %LET EmptyCol = ;
    %LET EmptyDef = ;
  %END; %* --- Indent empty or Auto;

%*~~~~~~~~~~~~~~~~~;
%* Indent = number ;
%*_________________;

  %ELSE %DO; %* &Indent_ NE empty;
    %LET Spacing0 = SPACING=0 ;
    %LET PrintCol = NOPRINT;                    %* to prevent column printing;

    %IF ( &N_Groups-&LeftVar GT 0 ) %THEN %LET GrpWidth = %EVAL (
         (&ClasSize-&Indent_-(&N_Groups-&LeftVar-1)*&Spacing)
        /(&N_Groups-&LeftVar) );
    %ELSE %LET GrpWidth = &ClasSize; %* (probably) not used or ignored;
/*=========
3-     %LET GrpWidth = %EVAL ( (&ClasSize-&Indent_-&Spacing)/2 );
3a     %LET GrpWidth = %EVAL ( &ClasSize-&Indent_ );
2-     %LET GrpWidth = %EVAL ( &ClasSize-&Indent_ );
2a     %LET GrpWidth = &ClasSize; %* probably ignored width with across;
1-     %LET GrpWidth = &ClasSize; %* not used;
1a     %LET GrpWidth = &ClasSize; %* not used;
=========*/
    %LET NextVar = %EVAL(&LeftVar+1);
    %IF       ( &LeftLbl_ EQ C ) %THEN %LET EmptyLbl =  &&Grp&LeftVar.Lbl ;
    %ELSE %IF ( &LeftLbl_ EQ N ) %THEN %LET NextLbl  = "&&Grp&LeftVar.Lbl"
                                               'x' "&&Grp&NextVar.Lbl";
    %ELSE %IF ( &LeftLbl_ EQ V ) %THEN %LET LblAsVal = "&&Grp&LeftVar.Lbl: ";
    %ELSE %IF ( &LeftLbl_ EQ H ) %THEN %LET LblAsHdr = "&&Grp&LeftVar.Lbl" "--";
/*  %ELSE %IF ( &LeftLbl_ EQ E ) OR &LeftLbl_ EQ %THEN ; %*nothing; */

    %IF ( &Indent_ EQ 0 ) %THEN %DO;
      %LET EmptyCol = ;
      %LET EmptyDef = ;
    %END; %* --- [&Indent_ EQ 0];
    %ELSE %DO; %* &Indent_ > 0;
      %LET EmptyCol = EmptyCol;
      %LET EmptyDef = %STR (
        DEFINE &EmptyCol / "&EmptyLbl" WIDTH=&Indent_ LEFT FLOW SPACING=0;
        COMPUTE &EmptyCol / CHAR LENGTH=1;
          &EmptyCol = ' ';
        ENDCOMP;
      );
    %END; %* --- [&Indent_ > 0];
  %END; %* &Indent_ NE empty;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Check GrpWidth value for sufficient width ;
%*___________________________________________;

  %IF (NOT %LENGTH(&ODS)) %THEN %DO; %* ---no ODS---;
    %IF &GrpWidth LT 1 %THEN %DO;
      %PUT *** &MacName *** &ERR: Remaining category width &GrpWidth insufficient.;
      %PUT * Enlarge TblWidth or reduce StatWdth or Across. Macro &MacName will abort.;
      %LET ErrCount = %EVAL ( &ErrCount + 1);
    %END;
    %ELSE %IF &GrpWidth LE 6 %THEN %DO;
      %PUT *** &MacName *** &WARN: Remaining category width &GrpWidth (too) small.;
      %PUT * Enlarge TblWidth or reduce StatWdth or Across. Macro &MacName will continue.;
    %END;
    %IF ( &ErrCount GT 0 ) %THEN %GOTO Interupt;

%* - - - - - - - - - - - - - - - - - - - - - - - - - -;
%* Process request for deviant width of Group1 column ;
%* - - - - - - - - - - - - - - - - - - - - - - - - - -;

    %IF (%LENGTH(%SUPERQ(Width1st)) AND ((&N_Groups GT 2 AND &Across NE 0)
      OR (&N_Groups GT 1 AND &Across EQ 0))) %THEN %DO; %* [30apr2014] ;
      %LET Grp1Wdth = %EVAL ( ((&ClasSize-&Width1st) - (&N_Groups-1-(&Across NE 0)) * &Spacing)
          / (&N_Groups-1-(&Across NE 0)) ); %* === scratch use of &Grp1Wdth === ;
      %IF ((&N_Groups-1-(&Across NE 0) GT 0) AND (&Width1st LT &GrpWidth OR
           &Grp1Wdth GE 4)) %THEN %DO;
        %LET GrpWidth = &Grp1Wdth; %* === scratch use of &Grp1Wdth === ;
        %LET Grp1Wdth = &Width1st; %* === final use of &Grp1Wdth === ;
      %END;
      %ELSE %DO;
        %PUT *** &MacName *** NOTE: Width1st request not accepted, too less remaining space;
        %PUT .                for each other column: &Grp1Wdth; %* === scratch use of &Grp1Wdth === ;
        %LET Grp1Wdth = &GrpWidth; %* all the same if not justified;
      %END;
    %END; %* Width1st specified;
    %ELSE %LET Grp1Wdth = &GrpWidth; %* all the same if not specified;

    %LET HeadHead = HEADLINE HEADSKIP;
    %LET HorLineA = '--' '  ';
    %LET HorLineB = '__' '  ';
    %LET HorLineC = "&LineLine" '  ';
    %LET LastSkip = SKIP;
  %END; %* (no ODS);

  %ELSE %DO; %* ---ODS---;
    %LET Grp1Wdth = GrpWidth; %* all the same with ODS (auto-adjusted);
    %LET HeadHead = ;
    %LET HorLineA = ;
    %LET HorLineB = ;
    %LET HorLineC = ;
    %LET LastSkip = ;
  %END;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Preparing pieces of code for PROC REPORT ;
%*__________________________________________;

  %IF ( &N_Groups GE 2 ) %THEN %DO;
    %IF ( &Across EQ 0 ) %THEN %DO;
      %LET DGroup2 = %STR (
        DEFINE &Group2 / GROUP WIDTH=&GrpWidth LEFT ORDER=&Order2 FLOW &FGrp2Fmt
                         &NextLbl %Spacing0;
        );
    %END;
    %ELSE /*%IF ( &Across GT 0 ) %THEN*/ %DO; /* negative values already made absolute */
      %LET DGroup2 = %STR (
        DEFINE &Group2 / GROUP WIDTH=&Grp1Wdth LEFT ORDER=&Order2 FLOW &FGrp2Fmt
                         &PrintCol SPACING=0;
        );
    %END;
  %END;

/*=========*/ %* @@@@@@@@@ NOT ALWAYS PERFECTLY SEPARATED YET @@@@@@@@@ ;
  %IF ( &N_Groups GE 3 ) %THEN %DO;
    %LET LastBut1 = %EVAL (&N_Groups - 1);
    %LET Break = %STR ( BREAK BEFORE &&Group&N_Groups / &LineSkip; );
    %IF (&LastGrpL GT 1) %THEN %LET Break = %STR(&Break)
/*[30apr2014]*/  %STR ( BREAK AFTER  &&Group&LastBut1 / &LastSkip; );
%* last but one gets optional line separator???;
  %END; %* --- [&N_Groups GE 3];
/*=========*/

  %IF (&NewPage GT 0) %THEN %DO;
    %LET Break = &Break %STR ( BREAK AFTER &&Group&NewPage / PAGE; );
  %END; %* --- [&NewPage GT 0];

/* @@@@@@@@@ How about if multiple BREAKs apply to the same variable(s) ? */

  %IF (&Debug EQ 8) %THEN %DO;
    OPTIONS MPRINT MERROR SERROR MLOGIC SYMBOLGEN MACROGEN;
  %END;

  %DO i = 4 %TO &N_Groups;
    %LET DGroup&i = %STR (
      DEFINE &&Group&i / GROUP WIDTH=&GrpWidth LEFT ORDER=&&Order&i FLOW
                                 &&FGrp&i.Fmt;
      );
  %END;

  %IF (&Debug EQ 8) %THEN %DO;
    OPTIONS noMPRINT noMERROR noSERROR noMLOGIC noSYMBOLGEN noMACROGEN;
  %END;

%*-----------------------3 groups, Across=0 : vertical-------------------------;
  %IF ( &Group3 NE AND &Across EQ 0 ) %THEN %DO;
    %LET DGroup3 = %STR (
      DEFINE &Group3 / GROUP WIDTH=&GrpWidth LEFT ORDER=&Order3 FLOW &FGrp3Fmt;
      );
/*=========
    %LET Break = %STR ( BREAK BEFORE &Group3 / &LineSkip;
                        BREAK AFTER  &Group2 / &LastSkip;
                      );
=========*/
  %END;

%*----------------------3 groups, Across~0 : horizontal------------------------;
  %ELSE %IF ( &Group3 NE AND &Across NE 0 ) %THEN %DO;
    %LET DGroup3 = %STR (
      DEFINE &Group3 / GROUP WIDTH=&GrpWidth LEFT ORDER=&Order3 FLOW &FGrp3Fmt
                       &NextLbl %Spacing0;
      );
/*=========
    %LET Break = %STR ( BREAK BEFORE &Group3 / &LineSkip;
                        BREAK AFTER  &Group2 / &LastSkip;
                      );
=========*/
  %END;

%*-----------------------2 groups, Across=0 : vertical-------------------------;
  %ELSE %IF ( &Group2 NE AND &Across EQ 0 ) %THEN %DO;
    %LET DGroup3 = ; %* empty  ;
    %LET Break = %STR ( BREAK BEFORE &Group2 / &LineSkip;
                        BREAK AFTER  &Group1 / &LastSkip;
                      );
    %LET Break = %STR ( BREAK BEFORE &Group2 / &LineSkip; );
    %IF (&LastGrpL GT 1) %THEN %LET Break = %STR(&Break)
/*[30apr2014]*/  %STR ( BREAK AFTER  &Group1 / &LastSkip; );
  %END;

%*----------------------2 groups, Across~0 : horizontal------------------------;
  %ELSE %IF ( &Group2 NE AND &Across NE 0 ) %THEN %DO;
    %LET DGroup3 = ; %* empty  ;
    %LET Break = %STR ( BREAK BEFORE &Group2 / &LineSkip; );
  %END;

%*-----------------------------------1 group-----------------------------------;
  %ELSE %IF ( &Group1 NE ) %THEN %DO;
    %LET DGroup2 = ; %* empty  ;
    %LET DGroup3 = ; %* empty  ;
    %IF (%FirstCh(&Across) EQ 0) %THEN /* 20 Oct 2005, not if Across NE 0 */
      %LET Break = %STR ( BREAK BEFORE &Group1 / &LineSkip; ); * 9 April 2004;
  %END;

%*-----------------------------------------------------------------------------;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Runtime definition of macro CompBloc ;
%*______________________________________;

%* Macro variables Across, Indent_, Grp#Var, Grp#Type, Group#N, Grp#Fmt,
%* LblAsVal local to parent;

  %MACRO CompBloc ;
    %LOCAL Nr; %* Group number 1 or 2, dependent on Across macro variable;
    %IF ( &Across EQ 0 ) %THEN %LET Nr = 1;       %* Process Across into Nr;
    %ELSE %LET Nr = 2;
    %IF ( &Indent_ NE ) %THEN %DO;                %* If indentation specified ;
      COMPUTE BEFORE &&Group&Nr;                  %* Define compute block before;
        LENGTH &GrpValue $100;
        &GrpValue = PUT (&&Group&Nr, &&Grp&Nr.Fmt);
        %IF (%FirstCh(&LineSpac) NE S AND NOT %LENGTH(&ODS)) %THEN LINE @1 ' ';; %* optional empty line;
        LINE @1 &LblAsVal &GrpValue $CHAR100.;
      ENDCOMP;
    %END; %* --- [&Indent_ NE ];

    %IF (NOT %LENGTH(&ODS)) %THEN %DO; %* ---no ODS---;
      %IF (&Separate GT 0) %THEN %DO;
        COMPUTE AFTER &&Group&Separate;
          %IF (%FirstCh(&LineSpac) NE S) %THEN LINE @1 ' ';; %* optional empty line;
          LINE @1 &LineLen* '_'; %* was &TblWidth;
/*      %IF (&Separate LT &N_Groups-1) %THEN*/        /* [below 08may2014] */
        %IF (&N_Groups LE 2) %THEN LINE @1 ' ';; %* empty line after separator;
        ENDCOMP;
      %END; %* (within table);
      %ELSE %DO; /* Always at the very end */
        COMPUTE AFTER;
          %IF (%FirstCh(&LineSpac) NE S) %THEN LINE @1 ' ';; %* optional empty line;
          LINE @1 &LineLen* '_'; %* was &TblWidth;
        ENDCOMP;
      %END; %* (at end of table);
    %END; %* (no ODS);
  %MEND CompBloc;

/*========= DEBUG =========
%* Disable attributed formats of groups (for debugging purposes);
   %IF &Group1 NE AND &Across EQ 0 %THEN %DO;
     %IF &Grp1Type EQ 1 %THEN %LET FGrp1Fmt = %STR ( F=&Grp1Wdth..0 );
   %END;
   %IF &Group2 NE %THEN %DO;
     %IF &Grp2Type EQ 1 %THEN %LET FGrp2Fmt = %STR ( F=&Grp1Wdth..0 );
   %END;
=========*/

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* SORT if ByGroups specified ;
%*____________________________;

  %IF ( &ByGroups NE ) %THEN %STR(PROC SORT DATA=&AggrData; BY &ByGroups; RUN;);

  %IF ( &Debug > 10 ) %THEN %DO;
    PROC PRINT DATA=&AggrData; TITLE "AggrData just before REPORT"; RUN;
  %END;

%*~~~~~~~~;
%* REPORT ;
%*________;

  OPTIONS MISSING=' '; %* Force missings to get printed as blanks;

  %IF (&Debug EQ 8) %THEN %DO;
    %IF (%LENGTH(&ODS)) %THEN ODS SELECT ALL;;
    PROC PRINT DATA=&AggrData; TITLE10 'Debug=8, listing of report data'; RUN;
    %IF (%LENGTH(&ODS)) %THEN ODS EXCLUDE ALL;;
    OPTIONS MPRINT MERROR SERROR MLOGIC SYMBOLGEN MACROGEN;
  %END;

  %IF (&Debug EQ 9) %THEN %DO;
    DATA Current.AggrData_Report; SET &AggrData; RUN;
  %END;
  %IF (%LENGTH(%SUPERQ(Out2))) %THEN %DO;
    DATA &Out2; SET &AggrData; RUN; * Input dataset to PROC REPORT;
  %END;

  %IF (%LENGTH(&ODS)) %THEN ODS SELECT ALL;;
    PROC REPORT DATA=&AggrData NOWD &HeadHead NOCENTER MISSING /*WRAP*/
      %IF (&Debug EQ 9 OR &Debug EQ -1) %THEN LIST; %* [30apr2014] ;
      %IF (%LENGTH(%SUPERQ(Split)) EQ 3) %THEN %DO; /* Split character between quotes */
        %IF (%SUBSTR(&Split,1,1) EQ %SUBSTR(&Split,3,1)
        AND (%SUBSTR(&Split,1,1) EQ %STR(%')
          OR %SUBSTR(&Split,1,1) EQ %STR(%"))) %THEN SPLIT=&Split;
      %END;
      %ELSE SPLIT="%SUBSTR(&Split,1,1)"; /* first character of Split */
      %IF ( %LENGTH(%SUPERQ(Spacing))  ) %THEN SPACING=&Spacing;
      %IF ( %LENGTH(%SUPERQ(LineSize)) ) %THEN LS=&LineSize;
      %IF ( %LENGTH(%SUPERQ(Out)) ) %THEN OUT=&Out; %* Output dataset;
      ;
      %IF ( &Titles_ NE 0 ) %THEN &Titling ;
      %IF ( &ByGroups NE ) %THEN %STR(BY &ByGroups;);

      %IF ( &Across EQ 0 ) %THEN %DO; %* ------- vertical -------;
        COLUMN ( /*'__'*/ &HorLineC &LblAsHdr &Group1 &EmptyCol
               &Group2 &Group3 &Group4 &Group5 &Group6 &Group7 &Group8 &Group9
          %IF ( %LENGTH(%SUPERQ(NofCases)) ) %THEN Count;
          %IF ( %LENGTH(%SUPERQ(TablePct)) ) %THEN Percent;
          %IF ( %LENGTH(%SUPERQ(ColPct))   ) %THEN &PctCol;
          %IF ( %LENGTH(%SUPERQ(RowPct))   ) %THEN _Pct_Row;
          %IF ( %LENGTH(%SUPERQ(TwoWyPct)) ) %THEN _Pct_Tbl;
          %IF ( %LENGTH(%SUPERQ(ColPcRef)) ) %THEN _Pct_Ref;
          /*_TYPE_ _TYPE_=Type_Var*/ );
        DEFINE &Group1 / GROUP WIDTH=&Grp1Wdth LEFT ORDER=&Order1 FLOW &FGrp1Fmt
                     &PrintCol SPACING=0;
      %END; %* --- vertical; %* --------------------------;

      %ELSE %DO; %* &Across NE 0; %* ------- horizontal -------;
        COLUMN ( /*'__'*/ &HorLineC &LblAsHdr &EmptyCol
                 &Group2 &Group3 &Group4 &Group5 &Group6 &Group7 &Group8 &Group9
                 &Group1,(&HorLineB
          %IF ( &NofCases NE ) %THEN Count;
          %IF ( &TablePct NE ) %THEN Percent;
          %IF ( &ColPct   NE ) %THEN &PctCol;
          %IF ( &RowPct   NE ) %THEN _Pct_Row;
          %IF ( &TwoWyPct NE ) %THEN _Pct_Tbl;
          %IF (%LENGTH(%SUPERQ(ColPcRef))) %THEN _Pct_Ref;         )
          /*_TYPE_ _TYPE_=Type_Var*/);
        DEFINE &Group1 / "&Grp1Lbl" &HorLineA ACROSS WIDTH=&GrpWidth CENTER
                         ORDER=&Order1 FLOW &FGrp1Fmt;
      %END; %* --- horizontal; %* --------------------------;

%* (Formatted) across variable values never wrap by themselves, may be split! ;
      &EmptyDef %DO I = 2 %TO &N_Groups; %UNQUOTE(&&DGroup&i) %END;
/*    &DGroup2 &DGroup3 &DGroup4 &DGroup5 &DGroup6 &DGroup7 &DGroup8 &DGroup9*/
      %IF ( &NofCases NE ) %THEN DEFINE Count    / &NofCases WIDTH=&StatWdth F=&StatWdth..0         RIGHT %Spacing0;;
      %IF ( &TablePct NE ) %THEN DEFINE Percent  / &TablePct WIDTH=&StatWdth F=&StatWdth..&Decimals RIGHT %Spacing0;;
      %IF ( &ColPct   NE ) %THEN DEFINE &PctCol  / &ColPct   WIDTH=&StatWdth F=&StatWdth..&Decimals RIGHT %Spacing0;;
      %IF ( &RowPct   NE ) %THEN DEFINE _Pct_Row / &RowPct   WIDTH=&StatWdth F=&StatWdth..&Decimals RIGHT %Spacing0;;
      %IF ( &TwoWyPct NE ) %THEN DEFINE _Pct_Tbl / &TwoWyPct WIDTH=&StatWdth F=&StatWdth..&Decimals RIGHT %Spacing0;;
      %IF (%LENGTH(%SUPERQ(ColPcRef))) %THEN DEFINE _Pct_Ref / &CpRefLbl WIDTH=&StatWdth F=&StatWdth..&Decimals RIGHT %Spacing0;;
      * DEFINE _TYPE_   / NOPRINT;
      * DEFINE Type_Var / NOPRINT;
      &Break %* BREAK statement(s);
      %CompBloc %* COMPUTE block(s);
  RUN; %* -- [PROC REPORT];
  %IF (%LENGTH(&ODS)) %THEN ODS EXCLUDE ALL;;

%IF (&Debug EQ 8) %THEN %DO;
  OPTIONS noMPRINT noMERROR noSERROR noMLOGIC noSYMBOLGEN noMACROGEN;
%END;

%*-----------------------------------------------------------------------------;

%Interupt:
%Finish:

  PROC DATASETS; DELETE /*&XtabData*/ /*&AggrPart*/ &AggrData; RUN; QUIT;

  OPTIONS MISSING="&oMissing" LINESIZE=&oLS; %* reset original options;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Process start time and stop time into run time and correct for midnight pass;
%*_____________________________________________________________________________;

  %IF ( %UPCASE(&ForMyUse) NE RECURSIVE ) %THEN %DO;
     %LET Timing = %SYSEVALF ( %SYSFUNC(TIME()) - &Timing );
     %IF ( &Timing < 0 ) %THEN %LET Timing = %SYSEVALF ( &Timing + 86400 );
     %PUT *** &MacName *** NOTE: The MACRO &MacName used &Timing seconds.;
%* Elapsed time;
  %END;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* ODS argument processing: if ANY value then again switch on LISTING
* and select all other destinations. @@@@@@@@@ Restore previous ODS state.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
  %IF (%LENGTH(&ODS)) %THEN %DO;
    ODS SELECT ALL; %* works correctly from EG (unlike ODS dest EXCLUDE ALL);
    ODS LISTING;
  %END;

  %IF ( &ErrCount GT 0 ) %THEN %DO;
    DATA _NULL_;
      ABORT /*ABEND*/;
    RUN;
  %END;

%Exit:

  %* Delete all temporary datasets if not called recursively;
  %IF (&ForMyUse NE RECURSIVE) %THEN %DO;
    %_DELETE_ (&Contents &XTabData &AggrPart &AggrData &Grp1Part &Grp1Data &Val0Data
               &Dummy __PctRef);
  %END;
%MEND Crosstab;

%* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ;
%* E n d   o f   C r o s s t a b   (9-dimensional crosstabulation with perc.s) ;
%* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ;

%*~~~~~~~~~~~~~~~~~~;
%* Auxiliary macros ;
%*__________________;

%*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
%* Macro Spacing0 returns current Spacing0 macro variable and makes it empty ;
%*___________________________________________________________________________;

%MACRO Spacing0 (ForMyUse=);
  %IF ( %UPCASE(&ForMyUse) = COMPILE ) %THEN %GOTO Finish;
  &Spacing0 /* this is the returned result */
  %LET Spacing0 = ; %* make macro variable empty;
  %Finish:
%MEND Spacing0;
